// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var args14093 = [];
var len__7651__auto___14112 = arguments.length;
var i__7652__auto___14114 = (0);
while(true){
if((i__7652__auto___14114 < len__7651__auto___14112)){
args14093.push((arguments[i__7652__auto___14114]));

var G__14115 = (i__7652__auto___14114 + (1));
i__7652__auto___14114 = G__14115;
continue;
} else {
}
break;
}

var G__14100 = args14093.length;
switch (G__14100) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14093.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async14106 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14106 = (function (f,blockable,meta14107){
this.f = f;
this.blockable = blockable;
this.meta14107 = meta14107;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14108,meta14107__$1){
var self__ = this;
var _14108__$1 = this;
return (new cljs.core.async.t_cljs$core$async14106(self__.f,self__.blockable,meta14107__$1));
});

cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14108){
var self__ = this;
var _14108__$1 = this;
return self__.meta14107;
});

cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async14106.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async14106.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta14107","meta14107",33199402,null)], null);
});

cljs.core.async.t_cljs$core$async14106.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14106.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14106";

cljs.core.async.t_cljs$core$async14106.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14106");
});

cljs.core.async.__GT_t_cljs$core$async14106 = (function cljs$core$async$__GT_t_cljs$core$async14106(f__$1,blockable__$1,meta14107){
return (new cljs.core.async.t_cljs$core$async14106(f__$1,blockable__$1,meta14107));
});

}

return (new cljs.core.async.t_cljs$core$async14106(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var args14137 = [];
var len__7651__auto___14149 = arguments.length;
var i__7652__auto___14150 = (0);
while(true){
if((i__7652__auto___14150 < len__7651__auto___14149)){
args14137.push((arguments[i__7652__auto___14150]));

var G__14151 = (i__7652__auto___14150 + (1));
i__7652__auto___14150 = G__14151;
continue;
} else {
}
break;
}

var G__14141 = args14137.length;
switch (G__14141) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14137.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str("buffer must be supplied when transducer is"),cljs.core.str("\n"),cljs.core.str("buf-or-n")].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var args14161 = [];
var len__7651__auto___14172 = arguments.length;
var i__7652__auto___14173 = (0);
while(true){
if((i__7652__auto___14173 < len__7651__auto___14172)){
args14161.push((arguments[i__7652__auto___14173]));

var G__14174 = (i__7652__auto___14173 + (1));
i__7652__auto___14173 = G__14174;
continue;
} else {
}
break;
}

var G__14169 = args14161.length;
switch (G__14169) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14161.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var args14189 = [];
var len__7651__auto___14200 = arguments.length;
var i__7652__auto___14201 = (0);
while(true){
if((i__7652__auto___14201 < len__7651__auto___14200)){
args14189.push((arguments[i__7652__auto___14201]));

var G__14202 = (i__7652__auto___14201 + (1));
i__7652__auto___14201 = G__14202;
continue;
} else {
}
break;
}

var G__14197 = args14189.length;
switch (G__14197) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14189.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_14220 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_14220);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_14220,ret){
return (function (){
return fn1.call(null,val_14220);
});})(val_14220,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var args14237 = [];
var len__7651__auto___14286 = arguments.length;
var i__7652__auto___14287 = (0);
while(true){
if((i__7652__auto___14287 < len__7651__auto___14286)){
args14237.push((arguments[i__7652__auto___14287]));

var G__14294 = (i__7652__auto___14287 + (1));
i__7652__auto___14287 = G__14294;
continue;
} else {
}
break;
}

var G__14263 = args14237.length;
switch (G__14263) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14237.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4655__auto__)){
var ret = temp__4655__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4655__auto__)){
var retb = temp__4655__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4655__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4655__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__7461__auto___14332 = n;
var x_14333 = (0);
while(true){
if((x_14333 < n__7461__auto___14332)){
(a[x_14333] = (0));

var G__14334 = (x_14333 + (1));
x_14333 = G__14334;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__14337 = (i + (1));
i = G__14337;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async14353 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14353 = (function (flag,meta14354){
this.flag = flag;
this.meta14354 = meta14354;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_14355,meta14354__$1){
var self__ = this;
var _14355__$1 = this;
return (new cljs.core.async.t_cljs$core$async14353(self__.flag,meta14354__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_14355){
var self__ = this;
var _14355__$1 = this;
return self__.meta14354;
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta14354","meta14354",-186274199,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async14353.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14353.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14353";

cljs.core.async.t_cljs$core$async14353.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14353");
});})(flag))
;

cljs.core.async.__GT_t_cljs$core$async14353 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async14353(flag__$1,meta14354){
return (new cljs.core.async.t_cljs$core$async14353(flag__$1,meta14354));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async14353(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async14411 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async14411 = (function (flag,cb,meta14412){
this.flag = flag;
this.cb = cb;
this.meta14412 = meta14412;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_14413,meta14412__$1){
var self__ = this;
var _14413__$1 = this;
return (new cljs.core.async.t_cljs$core$async14411(self__.flag,self__.cb,meta14412__$1));
});

cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_14413){
var self__ = this;
var _14413__$1 = this;
return self__.meta14412;
});

cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async14411.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async14411.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta14412","meta14412",1802991368,null)], null);
});

cljs.core.async.t_cljs$core$async14411.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async14411.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async14411";

cljs.core.async.t_cljs$core$async14411.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async14411");
});

cljs.core.async.__GT_t_cljs$core$async14411 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async14411(flag__$1,cb__$1,meta14412){
return (new cljs.core.async.t_cljs$core$async14411(flag__$1,cb__$1,meta14412));
});

}

return (new cljs.core.async.t_cljs$core$async14411(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14476_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14476_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__14477_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__14477_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__6543__auto__ = wport;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return port;
}
})()], null));
} else {
var G__14541 = (i + (1));
i = G__14541;
continue;
}
} else {
return null;
}
break;
}
})();
var or__6543__auto__ = ret;
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4657__auto__ = (function (){var and__6531__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__6531__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__6531__auto__;
}
})();
if(cljs.core.truth_(temp__4657__auto__)){
var got = temp__4657__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___14550 = arguments.length;
var i__7652__auto___14551 = (0);
while(true){
if((i__7652__auto___14551 < len__7651__auto___14550)){
args__7658__auto__.push((arguments[i__7652__auto___14551]));

var G__14552 = (i__7652__auto___14551 + (1));
i__7652__auto___14551 = G__14552;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((1) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__7659__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__14546){
var map__14547 = p__14546;
var map__14547__$1 = ((((!((map__14547 == null)))?((((map__14547.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__14547.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__14547):map__14547);
var opts = map__14547__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq14542){
var G__14543 = cljs.core.first.call(null,seq14542);
var seq14542__$1 = cljs.core.next.call(null,seq14542);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__14543,seq14542__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var args14575 = [];
var len__7651__auto___14671 = arguments.length;
var i__7652__auto___14672 = (0);
while(true){
if((i__7652__auto___14672 < len__7651__auto___14671)){
args14575.push((arguments[i__7652__auto___14672]));

var G__14673 = (i__7652__auto___14672 + (1));
i__7652__auto___14672 = G__14673;
continue;
} else {
}
break;
}

var G__14577 = args14575.length;
switch (G__14577) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args14575.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__13855__auto___14675 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___14675){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___14675){
return (function (state_14623){
var state_val_14624 = (state_14623[(1)]);
if((state_val_14624 === (7))){
var inst_14615 = (state_14623[(2)]);
var state_14623__$1 = state_14623;
var statearr_14633_14676 = state_14623__$1;
(statearr_14633_14676[(2)] = inst_14615);

(statearr_14633_14676[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (1))){
var state_14623__$1 = state_14623;
var statearr_14634_14677 = state_14623__$1;
(statearr_14634_14677[(2)] = null);

(statearr_14634_14677[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (4))){
var inst_14593 = (state_14623[(7)]);
var inst_14593__$1 = (state_14623[(2)]);
var inst_14594 = (inst_14593__$1 == null);
var state_14623__$1 = (function (){var statearr_14638 = state_14623;
(statearr_14638[(7)] = inst_14593__$1);

return statearr_14638;
})();
if(cljs.core.truth_(inst_14594)){
var statearr_14639_14682 = state_14623__$1;
(statearr_14639_14682[(1)] = (5));

} else {
var statearr_14640_14684 = state_14623__$1;
(statearr_14640_14684[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (13))){
var state_14623__$1 = state_14623;
var statearr_14645_14686 = state_14623__$1;
(statearr_14645_14686[(2)] = null);

(statearr_14645_14686[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (6))){
var inst_14593 = (state_14623[(7)]);
var state_14623__$1 = state_14623;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14623__$1,(11),to,inst_14593);
} else {
if((state_val_14624 === (3))){
var inst_14618 = (state_14623[(2)]);
var state_14623__$1 = state_14623;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14623__$1,inst_14618);
} else {
if((state_val_14624 === (12))){
var state_14623__$1 = state_14623;
var statearr_14651_14696 = state_14623__$1;
(statearr_14651_14696[(2)] = null);

(statearr_14651_14696[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (2))){
var state_14623__$1 = state_14623;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14623__$1,(4),from);
} else {
if((state_val_14624 === (11))){
var inst_14603 = (state_14623[(2)]);
var state_14623__$1 = state_14623;
if(cljs.core.truth_(inst_14603)){
var statearr_14652_14702 = state_14623__$1;
(statearr_14652_14702[(1)] = (12));

} else {
var statearr_14653_14704 = state_14623__$1;
(statearr_14653_14704[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (9))){
var state_14623__$1 = state_14623;
var statearr_14654_14705 = state_14623__$1;
(statearr_14654_14705[(2)] = null);

(statearr_14654_14705[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (5))){
var state_14623__$1 = state_14623;
if(cljs.core.truth_(close_QMARK_)){
var statearr_14655_14706 = state_14623__$1;
(statearr_14655_14706[(1)] = (8));

} else {
var statearr_14656_14707 = state_14623__$1;
(statearr_14656_14707[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (14))){
var inst_14613 = (state_14623[(2)]);
var state_14623__$1 = state_14623;
var statearr_14658_14708 = state_14623__$1;
(statearr_14658_14708[(2)] = inst_14613);

(statearr_14658_14708[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (10))){
var inst_14600 = (state_14623[(2)]);
var state_14623__$1 = state_14623;
var statearr_14659_14709 = state_14623__$1;
(statearr_14659_14709[(2)] = inst_14600);

(statearr_14659_14709[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14624 === (8))){
var inst_14597 = cljs.core.async.close_BANG_.call(null,to);
var state_14623__$1 = state_14623;
var statearr_14660_14710 = state_14623__$1;
(statearr_14660_14710[(2)] = inst_14597);

(statearr_14660_14710[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___14675))
;
return ((function (switch__13839__auto__,c__13855__auto___14675){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_14667 = [null,null,null,null,null,null,null,null];
(statearr_14667[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_14667[(1)] = (1));

return statearr_14667;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_14623){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_14623);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e14668){if((e14668 instanceof Object)){
var ex__13843__auto__ = e14668;
var statearr_14669_14711 = state_14623;
(statearr_14669_14711[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14623);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14668;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__14718 = state_14623;
state_14623 = G__14718;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_14623){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_14623);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___14675))
})();
var state__13857__auto__ = (function (){var statearr_14670 = f__13856__auto__.call(null);
(statearr_14670[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___14675);

return statearr_14670;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___14675))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__14934){
var vec__14935 = p__14934;
var v = cljs.core.nth.call(null,vec__14935,(0),null);
var p = cljs.core.nth.call(null,vec__14935,(1),null);
var job = vec__14935;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__13855__auto___15134 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results){
return (function (state_14942){
var state_val_14943 = (state_14942[(1)]);
if((state_val_14943 === (1))){
var state_14942__$1 = state_14942;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_14942__$1,(2),res,v);
} else {
if((state_val_14943 === (2))){
var inst_14939 = (state_14942[(2)]);
var inst_14940 = cljs.core.async.close_BANG_.call(null,res);
var state_14942__$1 = (function (){var statearr_14944 = state_14942;
(statearr_14944[(7)] = inst_14939);

return statearr_14944;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14942__$1,inst_14940);
} else {
return null;
}
}
});})(c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results))
;
return ((function (switch__13839__auto__,c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_14948 = [null,null,null,null,null,null,null,null];
(statearr_14948[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__);

(statearr_14948[(1)] = (1));

return statearr_14948;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1 = (function (state_14942){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_14942);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e14949){if((e14949 instanceof Object)){
var ex__13843__auto__ = e14949;
var statearr_14950_15142 = state_14942;
(statearr_14950_15142[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14942);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14949;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15143 = state_14942;
state_14942 = G__15143;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = function(state_14942){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1.call(this,state_14942);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results))
})();
var state__13857__auto__ = (function (){var statearr_14951 = f__13856__auto__.call(null);
(statearr_14951[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___15134);

return statearr_14951;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___15134,res,vec__14935,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__14953){
var vec__14954 = p__14953;
var v = cljs.core.nth.call(null,vec__14954,(0),null);
var p = cljs.core.nth.call(null,vec__14954,(1),null);
var job = vec__14954;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__7461__auto___15147 = n;
var __15148 = (0);
while(true){
if((__15148 < n__7461__auto___15147)){
var G__14957_15149 = (((type instanceof cljs.core.Keyword))?type.fqn:null);
switch (G__14957_15149) {
case "compute":
var c__13855__auto___15152 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__15148,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (__15148,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function (state_14970){
var state_val_14971 = (state_14970[(1)]);
if((state_val_14971 === (1))){
var state_14970__$1 = state_14970;
var statearr_14974_15154 = state_14970__$1;
(statearr_14974_15154[(2)] = null);

(statearr_14974_15154[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14971 === (2))){
var state_14970__$1 = state_14970;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_14970__$1,(4),jobs);
} else {
if((state_val_14971 === (3))){
var inst_14968 = (state_14970[(2)]);
var state_14970__$1 = state_14970;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_14970__$1,inst_14968);
} else {
if((state_val_14971 === (4))){
var inst_14960 = (state_14970[(2)]);
var inst_14961 = process.call(null,inst_14960);
var state_14970__$1 = state_14970;
if(cljs.core.truth_(inst_14961)){
var statearr_14975_15155 = state_14970__$1;
(statearr_14975_15155[(1)] = (5));

} else {
var statearr_14976_15156 = state_14970__$1;
(statearr_14976_15156[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14971 === (5))){
var state_14970__$1 = state_14970;
var statearr_14977_15157 = state_14970__$1;
(statearr_14977_15157[(2)] = null);

(statearr_14977_15157[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14971 === (6))){
var state_14970__$1 = state_14970;
var statearr_14978_15158 = state_14970__$1;
(statearr_14978_15158[(2)] = null);

(statearr_14978_15158[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_14971 === (7))){
var inst_14966 = (state_14970[(2)]);
var state_14970__$1 = state_14970;
var statearr_14980_15159 = state_14970__$1;
(statearr_14980_15159[(2)] = inst_14966);

(statearr_14980_15159[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__15148,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
;
return ((function (__15148,switch__13839__auto__,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_14985 = [null,null,null,null,null,null,null];
(statearr_14985[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__);

(statearr_14985[(1)] = (1));

return statearr_14985;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1 = (function (state_14970){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_14970);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e14986){if((e14986 instanceof Object)){
var ex__13843__auto__ = e14986;
var statearr_14987_15160 = state_14970;
(statearr_14987_15160[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_14970);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e14986;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15161 = state_14970;
state_14970 = G__15161;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = function(state_14970){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1.call(this,state_14970);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__;
})()
;})(__15148,switch__13839__auto__,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
})();
var state__13857__auto__ = (function (){var statearr_14988 = f__13856__auto__.call(null);
(statearr_14988[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___15152);

return statearr_14988;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(__15148,c__13855__auto___15152,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
);


break;
case "async":
var c__13855__auto___15162 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__15148,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (__15148,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function (state_15001){
var state_val_15002 = (state_15001[(1)]);
if((state_val_15002 === (1))){
var state_15001__$1 = state_15001;
var statearr_15003_15164 = state_15001__$1;
(statearr_15003_15164[(2)] = null);

(statearr_15003_15164[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15002 === (2))){
var state_15001__$1 = state_15001;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15001__$1,(4),jobs);
} else {
if((state_val_15002 === (3))){
var inst_14999 = (state_15001[(2)]);
var state_15001__$1 = state_15001;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15001__$1,inst_14999);
} else {
if((state_val_15002 === (4))){
var inst_14991 = (state_15001[(2)]);
var inst_14992 = async.call(null,inst_14991);
var state_15001__$1 = state_15001;
if(cljs.core.truth_(inst_14992)){
var statearr_15004_15165 = state_15001__$1;
(statearr_15004_15165[(1)] = (5));

} else {
var statearr_15005_15166 = state_15001__$1;
(statearr_15005_15166[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15002 === (5))){
var state_15001__$1 = state_15001;
var statearr_15006_15167 = state_15001__$1;
(statearr_15006_15167[(2)] = null);

(statearr_15006_15167[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15002 === (6))){
var state_15001__$1 = state_15001;
var statearr_15009_15169 = state_15001__$1;
(statearr_15009_15169[(2)] = null);

(statearr_15009_15169[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15002 === (7))){
var inst_14997 = (state_15001[(2)]);
var state_15001__$1 = state_15001;
var statearr_15010_15170 = state_15001__$1;
(statearr_15010_15170[(2)] = inst_14997);

(statearr_15010_15170[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__15148,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
;
return ((function (__15148,switch__13839__auto__,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_15014 = [null,null,null,null,null,null,null];
(statearr_15014[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__);

(statearr_15014[(1)] = (1));

return statearr_15014;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1 = (function (state_15001){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15001);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15015){if((e15015 instanceof Object)){
var ex__13843__auto__ = e15015;
var statearr_15016_15175 = state_15001;
(statearr_15016_15175[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15001);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15015;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15176 = state_15001;
state_15001 = G__15176;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = function(state_15001){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1.call(this,state_15001);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__;
})()
;})(__15148,switch__13839__auto__,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
})();
var state__13857__auto__ = (function (){var statearr_15017 = f__13856__auto__.call(null);
(statearr_15017[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___15162);

return statearr_15017;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(__15148,c__13855__auto___15162,G__14957_15149,n__7461__auto___15147,jobs,results,process,async))
);


break;
default:
throw (new Error([cljs.core.str("No matching clause: "),cljs.core.str(type)].join('')));

}

var G__15177 = (__15148 + (1));
__15148 = G__15177;
continue;
} else {
}
break;
}

var c__13855__auto___15178 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___15178,jobs,results,process,async){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___15178,jobs,results,process,async){
return (function (state_15039){
var state_val_15040 = (state_15039[(1)]);
if((state_val_15040 === (1))){
var state_15039__$1 = state_15039;
var statearr_15041_15179 = state_15039__$1;
(statearr_15041_15179[(2)] = null);

(statearr_15041_15179[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15040 === (2))){
var state_15039__$1 = state_15039;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15039__$1,(4),from);
} else {
if((state_val_15040 === (3))){
var inst_15037 = (state_15039[(2)]);
var state_15039__$1 = state_15039;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15039__$1,inst_15037);
} else {
if((state_val_15040 === (4))){
var inst_15020 = (state_15039[(7)]);
var inst_15020__$1 = (state_15039[(2)]);
var inst_15021 = (inst_15020__$1 == null);
var state_15039__$1 = (function (){var statearr_15042 = state_15039;
(statearr_15042[(7)] = inst_15020__$1);

return statearr_15042;
})();
if(cljs.core.truth_(inst_15021)){
var statearr_15043_15183 = state_15039__$1;
(statearr_15043_15183[(1)] = (5));

} else {
var statearr_15044_15184 = state_15039__$1;
(statearr_15044_15184[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15040 === (5))){
var inst_15023 = cljs.core.async.close_BANG_.call(null,jobs);
var state_15039__$1 = state_15039;
var statearr_15045_15185 = state_15039__$1;
(statearr_15045_15185[(2)] = inst_15023);

(statearr_15045_15185[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15040 === (6))){
var inst_15020 = (state_15039[(7)]);
var inst_15025 = (state_15039[(8)]);
var inst_15025__$1 = cljs.core.async.chan.call(null,(1));
var inst_15026 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_15027 = [inst_15020,inst_15025__$1];
var inst_15028 = (new cljs.core.PersistentVector(null,2,(5),inst_15026,inst_15027,null));
var state_15039__$1 = (function (){var statearr_15046 = state_15039;
(statearr_15046[(8)] = inst_15025__$1);

return statearr_15046;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15039__$1,(8),jobs,inst_15028);
} else {
if((state_val_15040 === (7))){
var inst_15035 = (state_15039[(2)]);
var state_15039__$1 = state_15039;
var statearr_15047_15188 = state_15039__$1;
(statearr_15047_15188[(2)] = inst_15035);

(statearr_15047_15188[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15040 === (8))){
var inst_15025 = (state_15039[(8)]);
var inst_15030 = (state_15039[(2)]);
var state_15039__$1 = (function (){var statearr_15048 = state_15039;
(statearr_15048[(9)] = inst_15030);

return statearr_15048;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15039__$1,(9),results,inst_15025);
} else {
if((state_val_15040 === (9))){
var inst_15032 = (state_15039[(2)]);
var state_15039__$1 = (function (){var statearr_15049 = state_15039;
(statearr_15049[(10)] = inst_15032);

return statearr_15049;
})();
var statearr_15050_15191 = state_15039__$1;
(statearr_15050_15191[(2)] = null);

(statearr_15050_15191[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___15178,jobs,results,process,async))
;
return ((function (switch__13839__auto__,c__13855__auto___15178,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_15054 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_15054[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__);

(statearr_15054[(1)] = (1));

return statearr_15054;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1 = (function (state_15039){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15039);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15055){if((e15055 instanceof Object)){
var ex__13843__auto__ = e15055;
var statearr_15056_15195 = state_15039;
(statearr_15056_15195[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15039);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15055;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15196 = state_15039;
state_15039 = G__15196;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = function(state_15039){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1.call(this,state_15039);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___15178,jobs,results,process,async))
})();
var state__13857__auto__ = (function (){var statearr_15057 = f__13856__auto__.call(null);
(statearr_15057[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___15178);

return statearr_15057;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___15178,jobs,results,process,async))
);


var c__13855__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto__,jobs,results,process,async){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto__,jobs,results,process,async){
return (function (state_15095){
var state_val_15096 = (state_15095[(1)]);
if((state_val_15096 === (7))){
var inst_15091 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
var statearr_15097_15197 = state_15095__$1;
(statearr_15097_15197[(2)] = inst_15091);

(statearr_15097_15197[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (20))){
var state_15095__$1 = state_15095;
var statearr_15098_15198 = state_15095__$1;
(statearr_15098_15198[(2)] = null);

(statearr_15098_15198[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (1))){
var state_15095__$1 = state_15095;
var statearr_15099_15199 = state_15095__$1;
(statearr_15099_15199[(2)] = null);

(statearr_15099_15199[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (4))){
var inst_15060 = (state_15095[(7)]);
var inst_15060__$1 = (state_15095[(2)]);
var inst_15061 = (inst_15060__$1 == null);
var state_15095__$1 = (function (){var statearr_15100 = state_15095;
(statearr_15100[(7)] = inst_15060__$1);

return statearr_15100;
})();
if(cljs.core.truth_(inst_15061)){
var statearr_15101_15200 = state_15095__$1;
(statearr_15101_15200[(1)] = (5));

} else {
var statearr_15102_15201 = state_15095__$1;
(statearr_15102_15201[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (15))){
var inst_15073 = (state_15095[(8)]);
var state_15095__$1 = state_15095;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15095__$1,(18),to,inst_15073);
} else {
if((state_val_15096 === (21))){
var inst_15086 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
var statearr_15103_15205 = state_15095__$1;
(statearr_15103_15205[(2)] = inst_15086);

(statearr_15103_15205[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (13))){
var inst_15088 = (state_15095[(2)]);
var state_15095__$1 = (function (){var statearr_15105 = state_15095;
(statearr_15105[(9)] = inst_15088);

return statearr_15105;
})();
var statearr_15106_15206 = state_15095__$1;
(statearr_15106_15206[(2)] = null);

(statearr_15106_15206[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (6))){
var inst_15060 = (state_15095[(7)]);
var state_15095__$1 = state_15095;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15095__$1,(11),inst_15060);
} else {
if((state_val_15096 === (17))){
var inst_15081 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
if(cljs.core.truth_(inst_15081)){
var statearr_15108_15210 = state_15095__$1;
(statearr_15108_15210[(1)] = (19));

} else {
var statearr_15109_15211 = state_15095__$1;
(statearr_15109_15211[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (3))){
var inst_15093 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15095__$1,inst_15093);
} else {
if((state_val_15096 === (12))){
var inst_15070 = (state_15095[(10)]);
var state_15095__$1 = state_15095;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15095__$1,(14),inst_15070);
} else {
if((state_val_15096 === (2))){
var state_15095__$1 = state_15095;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15095__$1,(4),results);
} else {
if((state_val_15096 === (19))){
var state_15095__$1 = state_15095;
var statearr_15110_15212 = state_15095__$1;
(statearr_15110_15212[(2)] = null);

(statearr_15110_15212[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (11))){
var inst_15070 = (state_15095[(2)]);
var state_15095__$1 = (function (){var statearr_15111 = state_15095;
(statearr_15111[(10)] = inst_15070);

return statearr_15111;
})();
var statearr_15112_15213 = state_15095__$1;
(statearr_15112_15213[(2)] = null);

(statearr_15112_15213[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (9))){
var state_15095__$1 = state_15095;
var statearr_15113_15214 = state_15095__$1;
(statearr_15113_15214[(2)] = null);

(statearr_15113_15214[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (5))){
var state_15095__$1 = state_15095;
if(cljs.core.truth_(close_QMARK_)){
var statearr_15114_15215 = state_15095__$1;
(statearr_15114_15215[(1)] = (8));

} else {
var statearr_15115_15216 = state_15095__$1;
(statearr_15115_15216[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (14))){
var inst_15073 = (state_15095[(8)]);
var inst_15075 = (state_15095[(11)]);
var inst_15073__$1 = (state_15095[(2)]);
var inst_15074 = (inst_15073__$1 == null);
var inst_15075__$1 = cljs.core.not.call(null,inst_15074);
var state_15095__$1 = (function (){var statearr_15116 = state_15095;
(statearr_15116[(8)] = inst_15073__$1);

(statearr_15116[(11)] = inst_15075__$1);

return statearr_15116;
})();
if(inst_15075__$1){
var statearr_15117_15217 = state_15095__$1;
(statearr_15117_15217[(1)] = (15));

} else {
var statearr_15118_15218 = state_15095__$1;
(statearr_15118_15218[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (16))){
var inst_15075 = (state_15095[(11)]);
var state_15095__$1 = state_15095;
var statearr_15119_15219 = state_15095__$1;
(statearr_15119_15219[(2)] = inst_15075);

(statearr_15119_15219[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (10))){
var inst_15067 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
var statearr_15120_15220 = state_15095__$1;
(statearr_15120_15220[(2)] = inst_15067);

(statearr_15120_15220[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (18))){
var inst_15078 = (state_15095[(2)]);
var state_15095__$1 = state_15095;
var statearr_15121_15221 = state_15095__$1;
(statearr_15121_15221[(2)] = inst_15078);

(statearr_15121_15221[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15096 === (8))){
var inst_15064 = cljs.core.async.close_BANG_.call(null,to);
var state_15095__$1 = state_15095;
var statearr_15122_15222 = state_15095__$1;
(statearr_15122_15222[(2)] = inst_15064);

(statearr_15122_15222[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto__,jobs,results,process,async))
;
return ((function (switch__13839__auto__,c__13855__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_15128 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_15128[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__);

(statearr_15128[(1)] = (1));

return statearr_15128;
});
var cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1 = (function (state_15095){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15095);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15129){if((e15129 instanceof Object)){
var ex__13843__auto__ = e15129;
var statearr_15130_15225 = state_15095;
(statearr_15130_15225[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15095);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15129;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15228 = state_15095;
state_15095 = G__15228;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__ = function(state_15095){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1.call(this,state_15095);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto__,jobs,results,process,async))
})();
var state__13857__auto__ = (function (){var statearr_15132 = f__13856__auto__.call(null);
(statearr_15132[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto__);

return statearr_15132;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto__,jobs,results,process,async))
);

return c__13855__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var args15229 = [];
var len__7651__auto___15235 = arguments.length;
var i__7652__auto___15236 = (0);
while(true){
if((i__7652__auto___15236 < len__7651__auto___15235)){
args15229.push((arguments[i__7652__auto___15236]));

var G__15237 = (i__7652__auto___15236 + (1));
i__7652__auto___15236 = G__15237;
continue;
} else {
}
break;
}

var G__15234 = args15229.length;
switch (G__15234) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15229.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var args15240 = [];
var len__7651__auto___15247 = arguments.length;
var i__7652__auto___15248 = (0);
while(true){
if((i__7652__auto___15248 < len__7651__auto___15247)){
args15240.push((arguments[i__7652__auto___15248]));

var G__15250 = (i__7652__auto___15248 + (1));
i__7652__auto___15248 = G__15250;
continue;
} else {
}
break;
}

var G__15244 = args15240.length;
switch (G__15244) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15240.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var args15255 = [];
var len__7651__auto___15318 = arguments.length;
var i__7652__auto___15319 = (0);
while(true){
if((i__7652__auto___15319 < len__7651__auto___15318)){
args15255.push((arguments[i__7652__auto___15319]));

var G__15320 = (i__7652__auto___15319 + (1));
i__7652__auto___15319 = G__15320;
continue;
} else {
}
break;
}

var G__15257 = args15255.length;
switch (G__15257) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15255.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__13855__auto___15325 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___15325,tc,fc){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___15325,tc,fc){
return (function (state_15283){
var state_val_15284 = (state_15283[(1)]);
if((state_val_15284 === (7))){
var inst_15279 = (state_15283[(2)]);
var state_15283__$1 = state_15283;
var statearr_15285_15332 = state_15283__$1;
(statearr_15285_15332[(2)] = inst_15279);

(statearr_15285_15332[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (1))){
var state_15283__$1 = state_15283;
var statearr_15286_15335 = state_15283__$1;
(statearr_15286_15335[(2)] = null);

(statearr_15286_15335[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (4))){
var inst_15260 = (state_15283[(7)]);
var inst_15260__$1 = (state_15283[(2)]);
var inst_15261 = (inst_15260__$1 == null);
var state_15283__$1 = (function (){var statearr_15287 = state_15283;
(statearr_15287[(7)] = inst_15260__$1);

return statearr_15287;
})();
if(cljs.core.truth_(inst_15261)){
var statearr_15288_15336 = state_15283__$1;
(statearr_15288_15336[(1)] = (5));

} else {
var statearr_15289_15337 = state_15283__$1;
(statearr_15289_15337[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (13))){
var state_15283__$1 = state_15283;
var statearr_15290_15338 = state_15283__$1;
(statearr_15290_15338[(2)] = null);

(statearr_15290_15338[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (6))){
var inst_15260 = (state_15283[(7)]);
var inst_15266 = p.call(null,inst_15260);
var state_15283__$1 = state_15283;
if(cljs.core.truth_(inst_15266)){
var statearr_15292_15342 = state_15283__$1;
(statearr_15292_15342[(1)] = (9));

} else {
var statearr_15293_15343 = state_15283__$1;
(statearr_15293_15343[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (3))){
var inst_15281 = (state_15283[(2)]);
var state_15283__$1 = state_15283;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15283__$1,inst_15281);
} else {
if((state_val_15284 === (12))){
var state_15283__$1 = state_15283;
var statearr_15295_15344 = state_15283__$1;
(statearr_15295_15344[(2)] = null);

(statearr_15295_15344[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (2))){
var state_15283__$1 = state_15283;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15283__$1,(4),ch);
} else {
if((state_val_15284 === (11))){
var inst_15260 = (state_15283[(7)]);
var inst_15270 = (state_15283[(2)]);
var state_15283__$1 = state_15283;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15283__$1,(8),inst_15270,inst_15260);
} else {
if((state_val_15284 === (9))){
var state_15283__$1 = state_15283;
var statearr_15297_15345 = state_15283__$1;
(statearr_15297_15345[(2)] = tc);

(statearr_15297_15345[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (5))){
var inst_15263 = cljs.core.async.close_BANG_.call(null,tc);
var inst_15264 = cljs.core.async.close_BANG_.call(null,fc);
var state_15283__$1 = (function (){var statearr_15298 = state_15283;
(statearr_15298[(8)] = inst_15263);

return statearr_15298;
})();
var statearr_15299_15346 = state_15283__$1;
(statearr_15299_15346[(2)] = inst_15264);

(statearr_15299_15346[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (14))){
var inst_15277 = (state_15283[(2)]);
var state_15283__$1 = state_15283;
var statearr_15300_15347 = state_15283__$1;
(statearr_15300_15347[(2)] = inst_15277);

(statearr_15300_15347[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (10))){
var state_15283__$1 = state_15283;
var statearr_15304_15349 = state_15283__$1;
(statearr_15304_15349[(2)] = fc);

(statearr_15304_15349[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15284 === (8))){
var inst_15272 = (state_15283[(2)]);
var state_15283__$1 = state_15283;
if(cljs.core.truth_(inst_15272)){
var statearr_15305_15350 = state_15283__$1;
(statearr_15305_15350[(1)] = (12));

} else {
var statearr_15306_15351 = state_15283__$1;
(statearr_15306_15351[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___15325,tc,fc))
;
return ((function (switch__13839__auto__,c__13855__auto___15325,tc,fc){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_15310 = [null,null,null,null,null,null,null,null,null];
(statearr_15310[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_15310[(1)] = (1));

return statearr_15310;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_15283){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15283);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15313){if((e15313 instanceof Object)){
var ex__13843__auto__ = e15313;
var statearr_15314_15352 = state_15283;
(statearr_15314_15352[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15283);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15313;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15353 = state_15283;
state_15283 = G__15353;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_15283){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_15283);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___15325,tc,fc))
})();
var state__13857__auto__ = (function (){var statearr_15317 = f__13856__auto__.call(null);
(statearr_15317[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___15325);

return statearr_15317;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___15325,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__13855__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto__){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto__){
return (function (state_15423){
var state_val_15424 = (state_15423[(1)]);
if((state_val_15424 === (7))){
var inst_15419 = (state_15423[(2)]);
var state_15423__$1 = state_15423;
var statearr_15425_15460 = state_15423__$1;
(statearr_15425_15460[(2)] = inst_15419);

(statearr_15425_15460[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (1))){
var inst_15402 = init;
var state_15423__$1 = (function (){var statearr_15426 = state_15423;
(statearr_15426[(7)] = inst_15402);

return statearr_15426;
})();
var statearr_15427_15465 = state_15423__$1;
(statearr_15427_15465[(2)] = null);

(statearr_15427_15465[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (4))){
var inst_15406 = (state_15423[(8)]);
var inst_15406__$1 = (state_15423[(2)]);
var inst_15407 = (inst_15406__$1 == null);
var state_15423__$1 = (function (){var statearr_15431 = state_15423;
(statearr_15431[(8)] = inst_15406__$1);

return statearr_15431;
})();
if(cljs.core.truth_(inst_15407)){
var statearr_15433_15470 = state_15423__$1;
(statearr_15433_15470[(1)] = (5));

} else {
var statearr_15434_15471 = state_15423__$1;
(statearr_15434_15471[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (6))){
var inst_15406 = (state_15423[(8)]);
var inst_15402 = (state_15423[(7)]);
var inst_15410 = (state_15423[(9)]);
var inst_15410__$1 = f.call(null,inst_15402,inst_15406);
var inst_15411 = cljs.core.reduced_QMARK_.call(null,inst_15410__$1);
var state_15423__$1 = (function (){var statearr_15435 = state_15423;
(statearr_15435[(9)] = inst_15410__$1);

return statearr_15435;
})();
if(inst_15411){
var statearr_15436_15481 = state_15423__$1;
(statearr_15436_15481[(1)] = (8));

} else {
var statearr_15437_15483 = state_15423__$1;
(statearr_15437_15483[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (3))){
var inst_15421 = (state_15423[(2)]);
var state_15423__$1 = state_15423;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15423__$1,inst_15421);
} else {
if((state_val_15424 === (2))){
var state_15423__$1 = state_15423;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15423__$1,(4),ch);
} else {
if((state_val_15424 === (9))){
var inst_15410 = (state_15423[(9)]);
var inst_15402 = inst_15410;
var state_15423__$1 = (function (){var statearr_15439 = state_15423;
(statearr_15439[(7)] = inst_15402);

return statearr_15439;
})();
var statearr_15440_15493 = state_15423__$1;
(statearr_15440_15493[(2)] = null);

(statearr_15440_15493[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (5))){
var inst_15402 = (state_15423[(7)]);
var state_15423__$1 = state_15423;
var statearr_15442_15503 = state_15423__$1;
(statearr_15442_15503[(2)] = inst_15402);

(statearr_15442_15503[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (10))){
var inst_15417 = (state_15423[(2)]);
var state_15423__$1 = state_15423;
var statearr_15443_15508 = state_15423__$1;
(statearr_15443_15508[(2)] = inst_15417);

(statearr_15443_15508[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15424 === (8))){
var inst_15410 = (state_15423[(9)]);
var inst_15413 = cljs.core.deref.call(null,inst_15410);
var state_15423__$1 = state_15423;
var statearr_15444_15512 = state_15423__$1;
(statearr_15444_15512[(2)] = inst_15413);

(statearr_15444_15512[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto__))
;
return ((function (switch__13839__auto__,c__13855__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__13840__auto__ = null;
var cljs$core$async$reduce_$_state_machine__13840__auto____0 = (function (){
var statearr_15452 = [null,null,null,null,null,null,null,null,null,null];
(statearr_15452[(0)] = cljs$core$async$reduce_$_state_machine__13840__auto__);

(statearr_15452[(1)] = (1));

return statearr_15452;
});
var cljs$core$async$reduce_$_state_machine__13840__auto____1 = (function (state_15423){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15423);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15453){if((e15453 instanceof Object)){
var ex__13843__auto__ = e15453;
var statearr_15455_15518 = state_15423;
(statearr_15455_15518[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15423);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15453;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15519 = state_15423;
state_15423 = G__15519;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__13840__auto__ = function(state_15423){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__13840__auto____1.call(this,state_15423);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__13840__auto____0;
cljs$core$async$reduce_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__13840__auto____1;
return cljs$core$async$reduce_$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto__))
})();
var state__13857__auto__ = (function (){var statearr_15456 = f__13856__auto__.call(null);
(statearr_15456[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto__);

return statearr_15456;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto__))
);

return c__13855__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__13855__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto__,f__$1){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto__,f__$1){
return (function (state_15552){
var state_val_15553 = (state_15552[(1)]);
if((state_val_15553 === (1))){
var inst_15547 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_15552__$1 = state_15552;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_15552__$1,(2),inst_15547);
} else {
if((state_val_15553 === (2))){
var inst_15549 = (state_15552[(2)]);
var inst_15550 = f__$1.call(null,inst_15549);
var state_15552__$1 = state_15552;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15552__$1,inst_15550);
} else {
return null;
}
}
});})(c__13855__auto__,f__$1))
;
return ((function (switch__13839__auto__,c__13855__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__13840__auto__ = null;
var cljs$core$async$transduce_$_state_machine__13840__auto____0 = (function (){
var statearr_15559 = [null,null,null,null,null,null,null];
(statearr_15559[(0)] = cljs$core$async$transduce_$_state_machine__13840__auto__);

(statearr_15559[(1)] = (1));

return statearr_15559;
});
var cljs$core$async$transduce_$_state_machine__13840__auto____1 = (function (state_15552){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15552);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15560){if((e15560 instanceof Object)){
var ex__13843__auto__ = e15560;
var statearr_15561_15571 = state_15552;
(statearr_15561_15571[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15552);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15560;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15574 = state_15552;
state_15552 = G__15574;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__13840__auto__ = function(state_15552){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__13840__auto____1.call(this,state_15552);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__13840__auto____0;
cljs$core$async$transduce_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__13840__auto____1;
return cljs$core$async$transduce_$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto__,f__$1))
})();
var state__13857__auto__ = (function (){var statearr_15562 = f__13856__auto__.call(null);
(statearr_15562[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto__);

return statearr_15562;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto__,f__$1))
);

return c__13855__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var args15577 = [];
var len__7651__auto___15645 = arguments.length;
var i__7652__auto___15646 = (0);
while(true){
if((i__7652__auto___15646 < len__7651__auto___15645)){
args15577.push((arguments[i__7652__auto___15646]));

var G__15647 = (i__7652__auto___15646 + (1));
i__7652__auto___15646 = G__15647;
continue;
} else {
}
break;
}

var G__15581 = args15577.length;
switch (G__15581) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args15577.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__13855__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto__){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto__){
return (function (state_15610){
var state_val_15611 = (state_15610[(1)]);
if((state_val_15611 === (7))){
var inst_15588 = (state_15610[(2)]);
var state_15610__$1 = state_15610;
var statearr_15612_15653 = state_15610__$1;
(statearr_15612_15653[(2)] = inst_15588);

(statearr_15612_15653[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (1))){
var inst_15582 = cljs.core.seq.call(null,coll);
var inst_15583 = inst_15582;
var state_15610__$1 = (function (){var statearr_15613 = state_15610;
(statearr_15613[(7)] = inst_15583);

return statearr_15613;
})();
var statearr_15614_15655 = state_15610__$1;
(statearr_15614_15655[(2)] = null);

(statearr_15614_15655[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (4))){
var inst_15583 = (state_15610[(7)]);
var inst_15586 = cljs.core.first.call(null,inst_15583);
var state_15610__$1 = state_15610;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_15610__$1,(7),ch,inst_15586);
} else {
if((state_val_15611 === (13))){
var inst_15604 = (state_15610[(2)]);
var state_15610__$1 = state_15610;
var statearr_15615_15663 = state_15610__$1;
(statearr_15615_15663[(2)] = inst_15604);

(statearr_15615_15663[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (6))){
var inst_15591 = (state_15610[(2)]);
var state_15610__$1 = state_15610;
if(cljs.core.truth_(inst_15591)){
var statearr_15616_15671 = state_15610__$1;
(statearr_15616_15671[(1)] = (8));

} else {
var statearr_15617_15674 = state_15610__$1;
(statearr_15617_15674[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (3))){
var inst_15608 = (state_15610[(2)]);
var state_15610__$1 = state_15610;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_15610__$1,inst_15608);
} else {
if((state_val_15611 === (12))){
var state_15610__$1 = state_15610;
var statearr_15618_15677 = state_15610__$1;
(statearr_15618_15677[(2)] = null);

(statearr_15618_15677[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (2))){
var inst_15583 = (state_15610[(7)]);
var state_15610__$1 = state_15610;
if(cljs.core.truth_(inst_15583)){
var statearr_15619_15682 = state_15610__$1;
(statearr_15619_15682[(1)] = (4));

} else {
var statearr_15620_15684 = state_15610__$1;
(statearr_15620_15684[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (11))){
var inst_15601 = cljs.core.async.close_BANG_.call(null,ch);
var state_15610__$1 = state_15610;
var statearr_15621_15686 = state_15610__$1;
(statearr_15621_15686[(2)] = inst_15601);

(statearr_15621_15686[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (9))){
var state_15610__$1 = state_15610;
if(cljs.core.truth_(close_QMARK_)){
var statearr_15626_15687 = state_15610__$1;
(statearr_15626_15687[(1)] = (11));

} else {
var statearr_15627_15689 = state_15610__$1;
(statearr_15627_15689[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (5))){
var inst_15583 = (state_15610[(7)]);
var state_15610__$1 = state_15610;
var statearr_15630_15690 = state_15610__$1;
(statearr_15630_15690[(2)] = inst_15583);

(statearr_15630_15690[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (10))){
var inst_15606 = (state_15610[(2)]);
var state_15610__$1 = state_15610;
var statearr_15631_15702 = state_15610__$1;
(statearr_15631_15702[(2)] = inst_15606);

(statearr_15631_15702[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_15611 === (8))){
var inst_15583 = (state_15610[(7)]);
var inst_15593 = cljs.core.next.call(null,inst_15583);
var inst_15583__$1 = inst_15593;
var state_15610__$1 = (function (){var statearr_15632 = state_15610;
(statearr_15632[(7)] = inst_15583__$1);

return statearr_15632;
})();
var statearr_15633_15706 = state_15610__$1;
(statearr_15633_15706[(2)] = null);

(statearr_15633_15706[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto__))
;
return ((function (switch__13839__auto__,c__13855__auto__){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_15639 = [null,null,null,null,null,null,null,null];
(statearr_15639[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_15639[(1)] = (1));

return statearr_15639;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_15610){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_15610);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e15640){if((e15640 instanceof Object)){
var ex__13843__auto__ = e15640;
var statearr_15641_15711 = state_15610;
(statearr_15641_15711[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_15610);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e15640;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__15716 = state_15610;
state_15610 = G__15716;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_15610){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_15610);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto__))
})();
var state__13857__auto__ = (function (){var statearr_15642 = f__13856__auto__.call(null);
(statearr_15642[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto__);

return statearr_15642;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto__))
);

return c__13855__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__7206__auto__ = (((_ == null))?null:_);
var m__7207__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,_);
} else {
var m__7207__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async16015 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16015 = (function (ch,cs,meta16016){
this.ch = ch;
this.cs = cs;
this.meta16016 = meta16016;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_16017,meta16016__$1){
var self__ = this;
var _16017__$1 = this;
return (new cljs.core.async.t_cljs$core$async16015(self__.ch,self__.cs,meta16016__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_16017){
var self__ = this;
var _16017__$1 = this;
return self__.meta16016;
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta16016","meta16016",394923730,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async16015.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16015.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16015";

cljs.core.async.t_cljs$core$async16015.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16015");
});})(cs))
;

cljs.core.async.__GT_t_cljs$core$async16015 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async16015(ch__$1,cs__$1,meta16016){
return (new cljs.core.async.t_cljs$core$async16015(ch__$1,cs__$1,meta16016));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async16015(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__13855__auto___16309 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___16309,cs,m,dchan,dctr,done){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___16309,cs,m,dchan,dctr,done){
return (function (state_16162){
var state_val_16163 = (state_16162[(1)]);
if((state_val_16163 === (7))){
var inst_16158 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16164_16316 = state_16162__$1;
(statearr_16164_16316[(2)] = inst_16158);

(statearr_16164_16316[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (20))){
var inst_16054 = (state_16162[(7)]);
var inst_16066 = cljs.core.first.call(null,inst_16054);
var inst_16067 = cljs.core.nth.call(null,inst_16066,(0),null);
var inst_16068 = cljs.core.nth.call(null,inst_16066,(1),null);
var state_16162__$1 = (function (){var statearr_16168 = state_16162;
(statearr_16168[(8)] = inst_16067);

return statearr_16168;
})();
if(cljs.core.truth_(inst_16068)){
var statearr_16169_16320 = state_16162__$1;
(statearr_16169_16320[(1)] = (22));

} else {
var statearr_16170_16321 = state_16162__$1;
(statearr_16170_16321[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (27))){
var inst_16106 = (state_16162[(9)]);
var inst_16023 = (state_16162[(10)]);
var inst_16100 = (state_16162[(11)]);
var inst_16098 = (state_16162[(12)]);
var inst_16106__$1 = cljs.core._nth.call(null,inst_16098,inst_16100);
var inst_16107 = cljs.core.async.put_BANG_.call(null,inst_16106__$1,inst_16023,done);
var state_16162__$1 = (function (){var statearr_16175 = state_16162;
(statearr_16175[(9)] = inst_16106__$1);

return statearr_16175;
})();
if(cljs.core.truth_(inst_16107)){
var statearr_16176_16322 = state_16162__$1;
(statearr_16176_16322[(1)] = (30));

} else {
var statearr_16177_16323 = state_16162__$1;
(statearr_16177_16323[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (1))){
var state_16162__$1 = state_16162;
var statearr_16178_16324 = state_16162__$1;
(statearr_16178_16324[(2)] = null);

(statearr_16178_16324[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (24))){
var inst_16054 = (state_16162[(7)]);
var inst_16073 = (state_16162[(2)]);
var inst_16074 = cljs.core.next.call(null,inst_16054);
var inst_16032 = inst_16074;
var inst_16033 = null;
var inst_16034 = (0);
var inst_16035 = (0);
var state_16162__$1 = (function (){var statearr_16179 = state_16162;
(statearr_16179[(13)] = inst_16033);

(statearr_16179[(14)] = inst_16032);

(statearr_16179[(15)] = inst_16035);

(statearr_16179[(16)] = inst_16073);

(statearr_16179[(17)] = inst_16034);

return statearr_16179;
})();
var statearr_16182_16326 = state_16162__$1;
(statearr_16182_16326[(2)] = null);

(statearr_16182_16326[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (39))){
var state_16162__$1 = state_16162;
var statearr_16187_16328 = state_16162__$1;
(statearr_16187_16328[(2)] = null);

(statearr_16187_16328[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (4))){
var inst_16023 = (state_16162[(10)]);
var inst_16023__$1 = (state_16162[(2)]);
var inst_16024 = (inst_16023__$1 == null);
var state_16162__$1 = (function (){var statearr_16188 = state_16162;
(statearr_16188[(10)] = inst_16023__$1);

return statearr_16188;
})();
if(cljs.core.truth_(inst_16024)){
var statearr_16189_16334 = state_16162__$1;
(statearr_16189_16334[(1)] = (5));

} else {
var statearr_16190_16335 = state_16162__$1;
(statearr_16190_16335[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (15))){
var inst_16033 = (state_16162[(13)]);
var inst_16032 = (state_16162[(14)]);
var inst_16035 = (state_16162[(15)]);
var inst_16034 = (state_16162[(17)]);
var inst_16050 = (state_16162[(2)]);
var inst_16051 = (inst_16035 + (1));
var tmp16184 = inst_16033;
var tmp16185 = inst_16032;
var tmp16186 = inst_16034;
var inst_16032__$1 = tmp16185;
var inst_16033__$1 = tmp16184;
var inst_16034__$1 = tmp16186;
var inst_16035__$1 = inst_16051;
var state_16162__$1 = (function (){var statearr_16191 = state_16162;
(statearr_16191[(18)] = inst_16050);

(statearr_16191[(13)] = inst_16033__$1);

(statearr_16191[(14)] = inst_16032__$1);

(statearr_16191[(15)] = inst_16035__$1);

(statearr_16191[(17)] = inst_16034__$1);

return statearr_16191;
})();
var statearr_16192_16336 = state_16162__$1;
(statearr_16192_16336[(2)] = null);

(statearr_16192_16336[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (21))){
var inst_16077 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16199_16338 = state_16162__$1;
(statearr_16199_16338[(2)] = inst_16077);

(statearr_16199_16338[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (31))){
var inst_16106 = (state_16162[(9)]);
var inst_16110 = done.call(null,null);
var inst_16111 = cljs.core.async.untap_STAR_.call(null,m,inst_16106);
var state_16162__$1 = (function (){var statearr_16200 = state_16162;
(statearr_16200[(19)] = inst_16110);

return statearr_16200;
})();
var statearr_16201_16341 = state_16162__$1;
(statearr_16201_16341[(2)] = inst_16111);

(statearr_16201_16341[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (32))){
var inst_16099 = (state_16162[(20)]);
var inst_16097 = (state_16162[(21)]);
var inst_16100 = (state_16162[(11)]);
var inst_16098 = (state_16162[(12)]);
var inst_16113 = (state_16162[(2)]);
var inst_16114 = (inst_16100 + (1));
var tmp16193 = inst_16099;
var tmp16194 = inst_16097;
var tmp16195 = inst_16098;
var inst_16097__$1 = tmp16194;
var inst_16098__$1 = tmp16195;
var inst_16099__$1 = tmp16193;
var inst_16100__$1 = inst_16114;
var state_16162__$1 = (function (){var statearr_16204 = state_16162;
(statearr_16204[(22)] = inst_16113);

(statearr_16204[(20)] = inst_16099__$1);

(statearr_16204[(21)] = inst_16097__$1);

(statearr_16204[(11)] = inst_16100__$1);

(statearr_16204[(12)] = inst_16098__$1);

return statearr_16204;
})();
var statearr_16205_16350 = state_16162__$1;
(statearr_16205_16350[(2)] = null);

(statearr_16205_16350[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (40))){
var inst_16130 = (state_16162[(23)]);
var inst_16134 = done.call(null,null);
var inst_16135 = cljs.core.async.untap_STAR_.call(null,m,inst_16130);
var state_16162__$1 = (function (){var statearr_16206 = state_16162;
(statearr_16206[(24)] = inst_16134);

return statearr_16206;
})();
var statearr_16207_16357 = state_16162__$1;
(statearr_16207_16357[(2)] = inst_16135);

(statearr_16207_16357[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (33))){
var inst_16117 = (state_16162[(25)]);
var inst_16123 = cljs.core.chunked_seq_QMARK_.call(null,inst_16117);
var state_16162__$1 = state_16162;
if(inst_16123){
var statearr_16208_16358 = state_16162__$1;
(statearr_16208_16358[(1)] = (36));

} else {
var statearr_16209_16359 = state_16162__$1;
(statearr_16209_16359[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (13))){
var inst_16044 = (state_16162[(26)]);
var inst_16047 = cljs.core.async.close_BANG_.call(null,inst_16044);
var state_16162__$1 = state_16162;
var statearr_16210_16360 = state_16162__$1;
(statearr_16210_16360[(2)] = inst_16047);

(statearr_16210_16360[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (22))){
var inst_16067 = (state_16162[(8)]);
var inst_16070 = cljs.core.async.close_BANG_.call(null,inst_16067);
var state_16162__$1 = state_16162;
var statearr_16211_16362 = state_16162__$1;
(statearr_16211_16362[(2)] = inst_16070);

(statearr_16211_16362[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (36))){
var inst_16117 = (state_16162[(25)]);
var inst_16125 = cljs.core.chunk_first.call(null,inst_16117);
var inst_16126 = cljs.core.chunk_rest.call(null,inst_16117);
var inst_16127 = cljs.core.count.call(null,inst_16125);
var inst_16097 = inst_16126;
var inst_16098 = inst_16125;
var inst_16099 = inst_16127;
var inst_16100 = (0);
var state_16162__$1 = (function (){var statearr_16212 = state_16162;
(statearr_16212[(20)] = inst_16099);

(statearr_16212[(21)] = inst_16097);

(statearr_16212[(11)] = inst_16100);

(statearr_16212[(12)] = inst_16098);

return statearr_16212;
})();
var statearr_16213_16367 = state_16162__$1;
(statearr_16213_16367[(2)] = null);

(statearr_16213_16367[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (41))){
var inst_16117 = (state_16162[(25)]);
var inst_16137 = (state_16162[(2)]);
var inst_16138 = cljs.core.next.call(null,inst_16117);
var inst_16097 = inst_16138;
var inst_16098 = null;
var inst_16099 = (0);
var inst_16100 = (0);
var state_16162__$1 = (function (){var statearr_16215 = state_16162;
(statearr_16215[(27)] = inst_16137);

(statearr_16215[(20)] = inst_16099);

(statearr_16215[(21)] = inst_16097);

(statearr_16215[(11)] = inst_16100);

(statearr_16215[(12)] = inst_16098);

return statearr_16215;
})();
var statearr_16216_16372 = state_16162__$1;
(statearr_16216_16372[(2)] = null);

(statearr_16216_16372[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (43))){
var state_16162__$1 = state_16162;
var statearr_16217_16378 = state_16162__$1;
(statearr_16217_16378[(2)] = null);

(statearr_16217_16378[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (29))){
var inst_16146 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16223_16380 = state_16162__$1;
(statearr_16223_16380[(2)] = inst_16146);

(statearr_16223_16380[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (44))){
var inst_16155 = (state_16162[(2)]);
var state_16162__$1 = (function (){var statearr_16224 = state_16162;
(statearr_16224[(28)] = inst_16155);

return statearr_16224;
})();
var statearr_16225_16384 = state_16162__$1;
(statearr_16225_16384[(2)] = null);

(statearr_16225_16384[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (6))){
var inst_16087 = (state_16162[(29)]);
var inst_16086 = cljs.core.deref.call(null,cs);
var inst_16087__$1 = cljs.core.keys.call(null,inst_16086);
var inst_16088 = cljs.core.count.call(null,inst_16087__$1);
var inst_16089 = cljs.core.reset_BANG_.call(null,dctr,inst_16088);
var inst_16095 = cljs.core.seq.call(null,inst_16087__$1);
var inst_16097 = inst_16095;
var inst_16098 = null;
var inst_16099 = (0);
var inst_16100 = (0);
var state_16162__$1 = (function (){var statearr_16227 = state_16162;
(statearr_16227[(29)] = inst_16087__$1);

(statearr_16227[(30)] = inst_16089);

(statearr_16227[(20)] = inst_16099);

(statearr_16227[(21)] = inst_16097);

(statearr_16227[(11)] = inst_16100);

(statearr_16227[(12)] = inst_16098);

return statearr_16227;
})();
var statearr_16228_16386 = state_16162__$1;
(statearr_16228_16386[(2)] = null);

(statearr_16228_16386[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (28))){
var inst_16117 = (state_16162[(25)]);
var inst_16097 = (state_16162[(21)]);
var inst_16117__$1 = cljs.core.seq.call(null,inst_16097);
var state_16162__$1 = (function (){var statearr_16229 = state_16162;
(statearr_16229[(25)] = inst_16117__$1);

return statearr_16229;
})();
if(inst_16117__$1){
var statearr_16230_16387 = state_16162__$1;
(statearr_16230_16387[(1)] = (33));

} else {
var statearr_16231_16388 = state_16162__$1;
(statearr_16231_16388[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (25))){
var inst_16099 = (state_16162[(20)]);
var inst_16100 = (state_16162[(11)]);
var inst_16103 = (inst_16100 < inst_16099);
var inst_16104 = inst_16103;
var state_16162__$1 = state_16162;
if(cljs.core.truth_(inst_16104)){
var statearr_16232_16389 = state_16162__$1;
(statearr_16232_16389[(1)] = (27));

} else {
var statearr_16233_16390 = state_16162__$1;
(statearr_16233_16390[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (34))){
var state_16162__$1 = state_16162;
var statearr_16240_16391 = state_16162__$1;
(statearr_16240_16391[(2)] = null);

(statearr_16240_16391[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (17))){
var state_16162__$1 = state_16162;
var statearr_16241_16392 = state_16162__$1;
(statearr_16241_16392[(2)] = null);

(statearr_16241_16392[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (3))){
var inst_16160 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16162__$1,inst_16160);
} else {
if((state_val_16163 === (12))){
var inst_16082 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16242_16401 = state_16162__$1;
(statearr_16242_16401[(2)] = inst_16082);

(statearr_16242_16401[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (2))){
var state_16162__$1 = state_16162;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16162__$1,(4),ch);
} else {
if((state_val_16163 === (23))){
var state_16162__$1 = state_16162;
var statearr_16244_16406 = state_16162__$1;
(statearr_16244_16406[(2)] = null);

(statearr_16244_16406[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (35))){
var inst_16144 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16246_16407 = state_16162__$1;
(statearr_16246_16407[(2)] = inst_16144);

(statearr_16246_16407[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (19))){
var inst_16054 = (state_16162[(7)]);
var inst_16058 = cljs.core.chunk_first.call(null,inst_16054);
var inst_16059 = cljs.core.chunk_rest.call(null,inst_16054);
var inst_16060 = cljs.core.count.call(null,inst_16058);
var inst_16032 = inst_16059;
var inst_16033 = inst_16058;
var inst_16034 = inst_16060;
var inst_16035 = (0);
var state_16162__$1 = (function (){var statearr_16248 = state_16162;
(statearr_16248[(13)] = inst_16033);

(statearr_16248[(14)] = inst_16032);

(statearr_16248[(15)] = inst_16035);

(statearr_16248[(17)] = inst_16034);

return statearr_16248;
})();
var statearr_16249_16416 = state_16162__$1;
(statearr_16249_16416[(2)] = null);

(statearr_16249_16416[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (11))){
var inst_16032 = (state_16162[(14)]);
var inst_16054 = (state_16162[(7)]);
var inst_16054__$1 = cljs.core.seq.call(null,inst_16032);
var state_16162__$1 = (function (){var statearr_16254 = state_16162;
(statearr_16254[(7)] = inst_16054__$1);

return statearr_16254;
})();
if(inst_16054__$1){
var statearr_16255_16419 = state_16162__$1;
(statearr_16255_16419[(1)] = (16));

} else {
var statearr_16256_16420 = state_16162__$1;
(statearr_16256_16420[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (9))){
var inst_16084 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16257_16422 = state_16162__$1;
(statearr_16257_16422[(2)] = inst_16084);

(statearr_16257_16422[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (5))){
var inst_16030 = cljs.core.deref.call(null,cs);
var inst_16031 = cljs.core.seq.call(null,inst_16030);
var inst_16032 = inst_16031;
var inst_16033 = null;
var inst_16034 = (0);
var inst_16035 = (0);
var state_16162__$1 = (function (){var statearr_16258 = state_16162;
(statearr_16258[(13)] = inst_16033);

(statearr_16258[(14)] = inst_16032);

(statearr_16258[(15)] = inst_16035);

(statearr_16258[(17)] = inst_16034);

return statearr_16258;
})();
var statearr_16260_16427 = state_16162__$1;
(statearr_16260_16427[(2)] = null);

(statearr_16260_16427[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (14))){
var state_16162__$1 = state_16162;
var statearr_16261_16429 = state_16162__$1;
(statearr_16261_16429[(2)] = null);

(statearr_16261_16429[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (45))){
var inst_16152 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16262_16430 = state_16162__$1;
(statearr_16262_16430[(2)] = inst_16152);

(statearr_16262_16430[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (26))){
var inst_16087 = (state_16162[(29)]);
var inst_16148 = (state_16162[(2)]);
var inst_16149 = cljs.core.seq.call(null,inst_16087);
var state_16162__$1 = (function (){var statearr_16264 = state_16162;
(statearr_16264[(31)] = inst_16148);

return statearr_16264;
})();
if(inst_16149){
var statearr_16265_16431 = state_16162__$1;
(statearr_16265_16431[(1)] = (42));

} else {
var statearr_16266_16432 = state_16162__$1;
(statearr_16266_16432[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (16))){
var inst_16054 = (state_16162[(7)]);
var inst_16056 = cljs.core.chunked_seq_QMARK_.call(null,inst_16054);
var state_16162__$1 = state_16162;
if(inst_16056){
var statearr_16267_16433 = state_16162__$1;
(statearr_16267_16433[(1)] = (19));

} else {
var statearr_16268_16434 = state_16162__$1;
(statearr_16268_16434[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (38))){
var inst_16141 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16273_16435 = state_16162__$1;
(statearr_16273_16435[(2)] = inst_16141);

(statearr_16273_16435[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (30))){
var state_16162__$1 = state_16162;
var statearr_16274_16436 = state_16162__$1;
(statearr_16274_16436[(2)] = null);

(statearr_16274_16436[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (10))){
var inst_16033 = (state_16162[(13)]);
var inst_16035 = (state_16162[(15)]);
var inst_16043 = cljs.core._nth.call(null,inst_16033,inst_16035);
var inst_16044 = cljs.core.nth.call(null,inst_16043,(0),null);
var inst_16045 = cljs.core.nth.call(null,inst_16043,(1),null);
var state_16162__$1 = (function (){var statearr_16275 = state_16162;
(statearr_16275[(26)] = inst_16044);

return statearr_16275;
})();
if(cljs.core.truth_(inst_16045)){
var statearr_16276_16439 = state_16162__$1;
(statearr_16276_16439[(1)] = (13));

} else {
var statearr_16277_16441 = state_16162__$1;
(statearr_16277_16441[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (18))){
var inst_16080 = (state_16162[(2)]);
var state_16162__$1 = state_16162;
var statearr_16278_16442 = state_16162__$1;
(statearr_16278_16442[(2)] = inst_16080);

(statearr_16278_16442[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (42))){
var state_16162__$1 = state_16162;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_16162__$1,(45),dchan);
} else {
if((state_val_16163 === (37))){
var inst_16117 = (state_16162[(25)]);
var inst_16023 = (state_16162[(10)]);
var inst_16130 = (state_16162[(23)]);
var inst_16130__$1 = cljs.core.first.call(null,inst_16117);
var inst_16131 = cljs.core.async.put_BANG_.call(null,inst_16130__$1,inst_16023,done);
var state_16162__$1 = (function (){var statearr_16279 = state_16162;
(statearr_16279[(23)] = inst_16130__$1);

return statearr_16279;
})();
if(cljs.core.truth_(inst_16131)){
var statearr_16280_16443 = state_16162__$1;
(statearr_16280_16443[(1)] = (39));

} else {
var statearr_16281_16444 = state_16162__$1;
(statearr_16281_16444[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16163 === (8))){
var inst_16035 = (state_16162[(15)]);
var inst_16034 = (state_16162[(17)]);
var inst_16037 = (inst_16035 < inst_16034);
var inst_16038 = inst_16037;
var state_16162__$1 = state_16162;
if(cljs.core.truth_(inst_16038)){
var statearr_16282_16445 = state_16162__$1;
(statearr_16282_16445[(1)] = (10));

} else {
var statearr_16283_16446 = state_16162__$1;
(statearr_16283_16446[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___16309,cs,m,dchan,dctr,done))
;
return ((function (switch__13839__auto__,c__13855__auto___16309,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__13840__auto__ = null;
var cljs$core$async$mult_$_state_machine__13840__auto____0 = (function (){
var statearr_16287 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16287[(0)] = cljs$core$async$mult_$_state_machine__13840__auto__);

(statearr_16287[(1)] = (1));

return statearr_16287;
});
var cljs$core$async$mult_$_state_machine__13840__auto____1 = (function (state_16162){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_16162);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e16288){if((e16288 instanceof Object)){
var ex__13843__auto__ = e16288;
var statearr_16289_16452 = state_16162;
(statearr_16289_16452[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16162);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16288;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__16453 = state_16162;
state_16162 = G__16453;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__13840__auto__ = function(state_16162){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__13840__auto____1.call(this,state_16162);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__13840__auto____0;
cljs$core$async$mult_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__13840__auto____1;
return cljs$core$async$mult_$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___16309,cs,m,dchan,dctr,done))
})();
var state__13857__auto__ = (function (){var statearr_16291 = f__13856__auto__.call(null);
(statearr_16291[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___16309);

return statearr_16291;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___16309,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var args16454 = [];
var len__7651__auto___16459 = arguments.length;
var i__7652__auto___16460 = (0);
while(true){
if((i__7652__auto___16460 < len__7651__auto___16459)){
args16454.push((arguments[i__7652__auto___16460]));

var G__16461 = (i__7652__auto___16460 + (1));
i__7652__auto___16460 = G__16461;
continue;
} else {
}
break;
}

var G__16458 = args16454.length;
switch (G__16458) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args16454.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m);
} else {
var m__7207__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,state_map);
} else {
var m__7207__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__7206__auto__ = (((m == null))?null:m);
var m__7207__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,m,mode);
} else {
var m__7207__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__7658__auto__ = [];
var len__7651__auto___16518 = arguments.length;
var i__7652__auto___16519 = (0);
while(true){
if((i__7652__auto___16519 < len__7651__auto___16518)){
args__7658__auto__.push((arguments[i__7652__auto___16519]));

var G__16520 = (i__7652__auto___16519 + (1));
i__7652__auto___16519 = G__16520;
continue;
} else {
}
break;
}

var argseq__7659__auto__ = ((((3) < args__7658__auto__.length))?(new cljs.core.IndexedSeq(args__7658__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__7659__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__16509){
var map__16510 = p__16509;
var map__16510__$1 = ((((!((map__16510 == null)))?((((map__16510.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__16510.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__16510):map__16510);
var opts = map__16510__$1;
var statearr_16512_16522 = state;
(statearr_16512_16522[cljs.core.async.impl.ioc_helpers.STATE_IDX] = cont_block);


var temp__4657__auto__ = cljs.core.async.do_alts.call(null,((function (map__16510,map__16510__$1,opts){
return (function (val){
var statearr_16513_16523 = state;
(statearr_16513_16523[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__16510,map__16510__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4657__auto__)){
var cb = temp__4657__auto__;
var statearr_16514_16524 = state;
(statearr_16514_16524[cljs.core.async.impl.ioc_helpers.VALUE_IDX] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq16502){
var G__16503 = cljs.core.first.call(null,seq16502);
var seq16502__$1 = cljs.core.next.call(null,seq16502);
var G__16504 = cljs.core.first.call(null,seq16502__$1);
var seq16502__$2 = cljs.core.next.call(null,seq16502__$1);
var G__16505 = cljs.core.first.call(null,seq16502__$2);
var seq16502__$3 = cljs.core.next.call(null,seq16502__$2);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__16503,G__16504,G__16505,seq16502__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,(((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async16736 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async16736 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta16737){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta16737 = meta16737;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_16738,meta16737__$1){
var self__ = this;
var _16738__$1 = this;
return (new cljs.core.async.t_cljs$core$async16736(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta16737__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_16738){
var self__ = this;
var _16738__$1 = this;
return self__.meta16737;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str([cljs.core.str("mode must be one of: "),cljs.core.str(self__.solo_modes)].join('')),cljs.core.str("\n"),cljs.core.str("(solo-modes mode)")].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta16737","meta16737",-881171748,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async16736.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async16736.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async16736";

cljs.core.async.t_cljs$core$async16736.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async16736");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.__GT_t_cljs$core$async16736 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async16736(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta16737){
return (new cljs.core.async.t_cljs$core$async16736(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta16737));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async16736(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13855__auto___16929 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_16844){
var state_val_16845 = (state_16844[(1)]);
if((state_val_16845 === (7))){
var inst_16758 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
var statearr_16846_16930 = state_16844__$1;
(statearr_16846_16930[(2)] = inst_16758);

(statearr_16846_16930[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (20))){
var inst_16770 = (state_16844[(7)]);
var state_16844__$1 = state_16844;
var statearr_16847_16931 = state_16844__$1;
(statearr_16847_16931[(2)] = inst_16770);

(statearr_16847_16931[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (27))){
var state_16844__$1 = state_16844;
var statearr_16851_16932 = state_16844__$1;
(statearr_16851_16932[(2)] = null);

(statearr_16851_16932[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (1))){
var inst_16745 = (state_16844[(8)]);
var inst_16745__$1 = calc_state.call(null);
var inst_16747 = (inst_16745__$1 == null);
var inst_16748 = cljs.core.not.call(null,inst_16747);
var state_16844__$1 = (function (){var statearr_16852 = state_16844;
(statearr_16852[(8)] = inst_16745__$1);

return statearr_16852;
})();
if(inst_16748){
var statearr_16853_16933 = state_16844__$1;
(statearr_16853_16933[(1)] = (2));

} else {
var statearr_16854_16934 = state_16844__$1;
(statearr_16854_16934[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (24))){
var inst_16795 = (state_16844[(9)]);
var inst_16804 = (state_16844[(10)]);
var inst_16818 = (state_16844[(11)]);
var inst_16818__$1 = inst_16795.call(null,inst_16804);
var state_16844__$1 = (function (){var statearr_16855 = state_16844;
(statearr_16855[(11)] = inst_16818__$1);

return statearr_16855;
})();
if(cljs.core.truth_(inst_16818__$1)){
var statearr_16856_16936 = state_16844__$1;
(statearr_16856_16936[(1)] = (29));

} else {
var statearr_16857_16938 = state_16844__$1;
(statearr_16857_16938[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (4))){
var inst_16761 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16761)){
var statearr_16858_16939 = state_16844__$1;
(statearr_16858_16939[(1)] = (8));

} else {
var statearr_16859_16940 = state_16844__$1;
(statearr_16859_16940[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (15))){
var inst_16789 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16789)){
var statearr_16860_16941 = state_16844__$1;
(statearr_16860_16941[(1)] = (19));

} else {
var statearr_16861_16944 = state_16844__$1;
(statearr_16861_16944[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (21))){
var inst_16794 = (state_16844[(12)]);
var inst_16794__$1 = (state_16844[(2)]);
var inst_16795 = cljs.core.get.call(null,inst_16794__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_16796 = cljs.core.get.call(null,inst_16794__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_16797 = cljs.core.get.call(null,inst_16794__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_16844__$1 = (function (){var statearr_16862 = state_16844;
(statearr_16862[(9)] = inst_16795);

(statearr_16862[(13)] = inst_16796);

(statearr_16862[(12)] = inst_16794__$1);

return statearr_16862;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_16844__$1,(22),inst_16797);
} else {
if((state_val_16845 === (31))){
var inst_16826 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16826)){
var statearr_16863_16949 = state_16844__$1;
(statearr_16863_16949[(1)] = (32));

} else {
var statearr_16864_16951 = state_16844__$1;
(statearr_16864_16951[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (32))){
var inst_16803 = (state_16844[(14)]);
var state_16844__$1 = state_16844;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_16844__$1,(35),out,inst_16803);
} else {
if((state_val_16845 === (33))){
var inst_16794 = (state_16844[(12)]);
var inst_16770 = inst_16794;
var state_16844__$1 = (function (){var statearr_16865 = state_16844;
(statearr_16865[(7)] = inst_16770);

return statearr_16865;
})();
var statearr_16866_16952 = state_16844__$1;
(statearr_16866_16952[(2)] = null);

(statearr_16866_16952[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (13))){
var inst_16770 = (state_16844[(7)]);
var inst_16777 = inst_16770.cljs$lang$protocol_mask$partition0$;
var inst_16779 = (inst_16777 & (64));
var inst_16780 = inst_16770.cljs$core$ISeq$;
var inst_16781 = (cljs.core.PROTOCOL_SENTINEL === inst_16780);
var inst_16782 = (inst_16779) || (inst_16781);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16782)){
var statearr_16867_16956 = state_16844__$1;
(statearr_16867_16956[(1)] = (16));

} else {
var statearr_16868_16957 = state_16844__$1;
(statearr_16868_16957[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (22))){
var inst_16803 = (state_16844[(14)]);
var inst_16804 = (state_16844[(10)]);
var inst_16802 = (state_16844[(2)]);
var inst_16803__$1 = cljs.core.nth.call(null,inst_16802,(0),null);
var inst_16804__$1 = cljs.core.nth.call(null,inst_16802,(1),null);
var inst_16805 = (inst_16803__$1 == null);
var inst_16806 = cljs.core._EQ_.call(null,inst_16804__$1,change);
var inst_16807 = (inst_16805) || (inst_16806);
var state_16844__$1 = (function (){var statearr_16869 = state_16844;
(statearr_16869[(14)] = inst_16803__$1);

(statearr_16869[(10)] = inst_16804__$1);

return statearr_16869;
})();
if(cljs.core.truth_(inst_16807)){
var statearr_16870_16958 = state_16844__$1;
(statearr_16870_16958[(1)] = (23));

} else {
var statearr_16871_16959 = state_16844__$1;
(statearr_16871_16959[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (36))){
var inst_16794 = (state_16844[(12)]);
var inst_16770 = inst_16794;
var state_16844__$1 = (function (){var statearr_16872 = state_16844;
(statearr_16872[(7)] = inst_16770);

return statearr_16872;
})();
var statearr_16873_16960 = state_16844__$1;
(statearr_16873_16960[(2)] = null);

(statearr_16873_16960[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (29))){
var inst_16818 = (state_16844[(11)]);
var state_16844__$1 = state_16844;
var statearr_16874_16961 = state_16844__$1;
(statearr_16874_16961[(2)] = inst_16818);

(statearr_16874_16961[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (6))){
var state_16844__$1 = state_16844;
var statearr_16875_16962 = state_16844__$1;
(statearr_16875_16962[(2)] = false);

(statearr_16875_16962[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (28))){
var inst_16814 = (state_16844[(2)]);
var inst_16815 = calc_state.call(null);
var inst_16770 = inst_16815;
var state_16844__$1 = (function (){var statearr_16876 = state_16844;
(statearr_16876[(15)] = inst_16814);

(statearr_16876[(7)] = inst_16770);

return statearr_16876;
})();
var statearr_16878_16969 = state_16844__$1;
(statearr_16878_16969[(2)] = null);

(statearr_16878_16969[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (25))){
var inst_16840 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
var statearr_16879_16970 = state_16844__$1;
(statearr_16879_16970[(2)] = inst_16840);

(statearr_16879_16970[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (34))){
var inst_16838 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
var statearr_16880_16971 = state_16844__$1;
(statearr_16880_16971[(2)] = inst_16838);

(statearr_16880_16971[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (17))){
var state_16844__$1 = state_16844;
var statearr_16881_16972 = state_16844__$1;
(statearr_16881_16972[(2)] = false);

(statearr_16881_16972[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (3))){
var state_16844__$1 = state_16844;
var statearr_16882_16973 = state_16844__$1;
(statearr_16882_16973[(2)] = false);

(statearr_16882_16973[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (12))){
var inst_16842 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_16844__$1,inst_16842);
} else {
if((state_val_16845 === (2))){
var inst_16745 = (state_16844[(8)]);
var inst_16750 = inst_16745.cljs$lang$protocol_mask$partition0$;
var inst_16751 = (inst_16750 & (64));
var inst_16752 = inst_16745.cljs$core$ISeq$;
var inst_16753 = (cljs.core.PROTOCOL_SENTINEL === inst_16752);
var inst_16754 = (inst_16751) || (inst_16753);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16754)){
var statearr_16883_16974 = state_16844__$1;
(statearr_16883_16974[(1)] = (5));

} else {
var statearr_16884_16975 = state_16844__$1;
(statearr_16884_16975[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (23))){
var inst_16803 = (state_16844[(14)]);
var inst_16809 = (inst_16803 == null);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16809)){
var statearr_16885_16976 = state_16844__$1;
(statearr_16885_16976[(1)] = (26));

} else {
var statearr_16886_16977 = state_16844__$1;
(statearr_16886_16977[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (35))){
var inst_16829 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
if(cljs.core.truth_(inst_16829)){
var statearr_16887_16978 = state_16844__$1;
(statearr_16887_16978[(1)] = (36));

} else {
var statearr_16888_16979 = state_16844__$1;
(statearr_16888_16979[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (19))){
var inst_16770 = (state_16844[(7)]);
var inst_16791 = cljs.core.apply.call(null,cljs.core.hash_map,inst_16770);
var state_16844__$1 = state_16844;
var statearr_16889_16980 = state_16844__$1;
(statearr_16889_16980[(2)] = inst_16791);

(statearr_16889_16980[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (11))){
var inst_16770 = (state_16844[(7)]);
var inst_16774 = (inst_16770 == null);
var inst_16775 = cljs.core.not.call(null,inst_16774);
var state_16844__$1 = state_16844;
if(inst_16775){
var statearr_16890_16981 = state_16844__$1;
(statearr_16890_16981[(1)] = (13));

} else {
var statearr_16891_16982 = state_16844__$1;
(statearr_16891_16982[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (9))){
var inst_16745 = (state_16844[(8)]);
var state_16844__$1 = state_16844;
var statearr_16892_16983 = state_16844__$1;
(statearr_16892_16983[(2)] = inst_16745);

(statearr_16892_16983[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (5))){
var state_16844__$1 = state_16844;
var statearr_16893_16984 = state_16844__$1;
(statearr_16893_16984[(2)] = true);

(statearr_16893_16984[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (14))){
var state_16844__$1 = state_16844;
var statearr_16894_16985 = state_16844__$1;
(statearr_16894_16985[(2)] = false);

(statearr_16894_16985[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (26))){
var inst_16804 = (state_16844[(10)]);
var inst_16811 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_16804);
var state_16844__$1 = state_16844;
var statearr_16895_16986 = state_16844__$1;
(statearr_16895_16986[(2)] = inst_16811);

(statearr_16895_16986[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (16))){
var state_16844__$1 = state_16844;
var statearr_16896_16987 = state_16844__$1;
(statearr_16896_16987[(2)] = true);

(statearr_16896_16987[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (38))){
var inst_16834 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
var statearr_16897_16988 = state_16844__$1;
(statearr_16897_16988[(2)] = inst_16834);

(statearr_16897_16988[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (30))){
var inst_16795 = (state_16844[(9)]);
var inst_16796 = (state_16844[(13)]);
var inst_16804 = (state_16844[(10)]);
var inst_16821 = cljs.core.empty_QMARK_.call(null,inst_16795);
var inst_16822 = inst_16796.call(null,inst_16804);
var inst_16823 = cljs.core.not.call(null,inst_16822);
var inst_16824 = (inst_16821) && (inst_16823);
var state_16844__$1 = state_16844;
var statearr_16898_16989 = state_16844__$1;
(statearr_16898_16989[(2)] = inst_16824);

(statearr_16898_16989[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (10))){
var inst_16745 = (state_16844[(8)]);
var inst_16766 = (state_16844[(2)]);
var inst_16767 = cljs.core.get.call(null,inst_16766,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_16768 = cljs.core.get.call(null,inst_16766,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_16769 = cljs.core.get.call(null,inst_16766,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_16770 = inst_16745;
var state_16844__$1 = (function (){var statearr_16899 = state_16844;
(statearr_16899[(16)] = inst_16767);

(statearr_16899[(17)] = inst_16768);

(statearr_16899[(7)] = inst_16770);

(statearr_16899[(18)] = inst_16769);

return statearr_16899;
})();
var statearr_16900_17004 = state_16844__$1;
(statearr_16900_17004[(2)] = null);

(statearr_16900_17004[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (18))){
var inst_16786 = (state_16844[(2)]);
var state_16844__$1 = state_16844;
var statearr_16901_17014 = state_16844__$1;
(statearr_16901_17014[(2)] = inst_16786);

(statearr_16901_17014[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (37))){
var state_16844__$1 = state_16844;
var statearr_16902_17020 = state_16844__$1;
(statearr_16902_17020[(2)] = null);

(statearr_16902_17020[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_16845 === (8))){
var inst_16745 = (state_16844[(8)]);
var inst_16763 = cljs.core.apply.call(null,cljs.core.hash_map,inst_16745);
var state_16844__$1 = state_16844;
var statearr_16903_17023 = state_16844__$1;
(statearr_16903_17023[(2)] = inst_16763);

(statearr_16903_17023[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__13839__auto__,c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__13840__auto__ = null;
var cljs$core$async$mix_$_state_machine__13840__auto____0 = (function (){
var statearr_16907 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_16907[(0)] = cljs$core$async$mix_$_state_machine__13840__auto__);

(statearr_16907[(1)] = (1));

return statearr_16907;
});
var cljs$core$async$mix_$_state_machine__13840__auto____1 = (function (state_16844){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_16844);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e16908){if((e16908 instanceof Object)){
var ex__13843__auto__ = e16908;
var statearr_16909_17027 = state_16844;
(statearr_16909_17027[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_16844);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e16908;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17031 = state_16844;
state_16844 = G__17031;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__13840__auto__ = function(state_16844){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__13840__auto____1.call(this,state_16844);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__13840__auto____0;
cljs$core$async$mix_$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__13840__auto____1;
return cljs$core$async$mix_$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__13857__auto__ = (function (){var statearr_16910 = f__13856__auto__.call(null);
(statearr_16910[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___16929);

return statearr_16910;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___16929,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__7207__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v,ch);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var args17045 = [];
var len__7651__auto___17073 = arguments.length;
var i__7652__auto___17074 = (0);
while(true){
if((i__7652__auto___17074 < len__7651__auto___17073)){
args17045.push((arguments[i__7652__auto___17074]));

var G__17078 = (i__7652__auto___17074 + (1));
i__7652__auto___17074 = G__17078;
continue;
} else {
}
break;
}

var G__17048 = args17045.length;
switch (G__17048) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17045.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__7206__auto__ = (((p == null))?null:p);
var m__7207__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__7206__auto__)]);
if(!((m__7207__auto__ == null))){
return m__7207__auto__.call(null,p,v);
} else {
var m__7207__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__7207__auto____$1 == null))){
return m__7207__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var args17094 = [];
var len__7651__auto___17241 = arguments.length;
var i__7652__auto___17242 = (0);
while(true){
if((i__7652__auto___17242 < len__7651__auto___17241)){
args17094.push((arguments[i__7652__auto___17242]));

var G__17243 = (i__7652__auto___17242 + (1));
i__7652__auto___17242 = G__17243;
continue;
} else {
}
break;
}

var G__17096 = args17094.length;
switch (G__17096) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17094.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__6543__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__6543__auto__)){
return or__6543__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__6543__auto__,mults){
return (function (p1__17093_SHARP_){
if(cljs.core.truth_(p1__17093_SHARP_.call(null,topic))){
return p1__17093_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__17093_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__6543__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async17097 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17097 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta17098){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta17098 = meta17098;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_17099,meta17098__$1){
var self__ = this;
var _17099__$1 = this;
return (new cljs.core.async.t_cljs$core$async17097(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta17098__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_17099){
var self__ = this;
var _17099__$1 = this;
return self__.meta17098;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4657__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4657__auto__)){
var m = temp__4657__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta17098","meta17098",333162825,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async17097.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17097.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17097";

cljs.core.async.t_cljs$core$async17097.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17097");
});})(mults,ensure_mult))
;

cljs.core.async.__GT_t_cljs$core$async17097 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async17097(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta17098){
return (new cljs.core.async.t_cljs$core$async17097(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta17098));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async17097(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__13855__auto___17256 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___17256,mults,ensure_mult,p){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___17256,mults,ensure_mult,p){
return (function (state_17171){
var state_val_17172 = (state_17171[(1)]);
if((state_val_17172 === (7))){
var inst_17167 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17173_17261 = state_17171__$1;
(statearr_17173_17261[(2)] = inst_17167);

(statearr_17173_17261[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (20))){
var state_17171__$1 = state_17171;
var statearr_17175_17262 = state_17171__$1;
(statearr_17175_17262[(2)] = null);

(statearr_17175_17262[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (1))){
var state_17171__$1 = state_17171;
var statearr_17176_17263 = state_17171__$1;
(statearr_17176_17263[(2)] = null);

(statearr_17176_17263[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (24))){
var inst_17150 = (state_17171[(7)]);
var inst_17159 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_17150);
var state_17171__$1 = state_17171;
var statearr_17178_17264 = state_17171__$1;
(statearr_17178_17264[(2)] = inst_17159);

(statearr_17178_17264[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (4))){
var inst_17102 = (state_17171[(8)]);
var inst_17102__$1 = (state_17171[(2)]);
var inst_17103 = (inst_17102__$1 == null);
var state_17171__$1 = (function (){var statearr_17179 = state_17171;
(statearr_17179[(8)] = inst_17102__$1);

return statearr_17179;
})();
if(cljs.core.truth_(inst_17103)){
var statearr_17180_17270 = state_17171__$1;
(statearr_17180_17270[(1)] = (5));

} else {
var statearr_17181_17275 = state_17171__$1;
(statearr_17181_17275[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (15))){
var inst_17144 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17183_17276 = state_17171__$1;
(statearr_17183_17276[(2)] = inst_17144);

(statearr_17183_17276[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (21))){
var inst_17164 = (state_17171[(2)]);
var state_17171__$1 = (function (){var statearr_17184 = state_17171;
(statearr_17184[(9)] = inst_17164);

return statearr_17184;
})();
var statearr_17185_17277 = state_17171__$1;
(statearr_17185_17277[(2)] = null);

(statearr_17185_17277[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (13))){
var inst_17126 = (state_17171[(10)]);
var inst_17128 = cljs.core.chunked_seq_QMARK_.call(null,inst_17126);
var state_17171__$1 = state_17171;
if(inst_17128){
var statearr_17187_17278 = state_17171__$1;
(statearr_17187_17278[(1)] = (16));

} else {
var statearr_17188_17280 = state_17171__$1;
(statearr_17188_17280[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (22))){
var inst_17156 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
if(cljs.core.truth_(inst_17156)){
var statearr_17189_17285 = state_17171__$1;
(statearr_17189_17285[(1)] = (23));

} else {
var statearr_17190_17287 = state_17171__$1;
(statearr_17190_17287[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (6))){
var inst_17102 = (state_17171[(8)]);
var inst_17150 = (state_17171[(7)]);
var inst_17152 = (state_17171[(11)]);
var inst_17150__$1 = topic_fn.call(null,inst_17102);
var inst_17151 = cljs.core.deref.call(null,mults);
var inst_17152__$1 = cljs.core.get.call(null,inst_17151,inst_17150__$1);
var state_17171__$1 = (function (){var statearr_17192 = state_17171;
(statearr_17192[(7)] = inst_17150__$1);

(statearr_17192[(11)] = inst_17152__$1);

return statearr_17192;
})();
if(cljs.core.truth_(inst_17152__$1)){
var statearr_17193_17291 = state_17171__$1;
(statearr_17193_17291[(1)] = (19));

} else {
var statearr_17194_17292 = state_17171__$1;
(statearr_17194_17292[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (25))){
var inst_17161 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17196_17293 = state_17171__$1;
(statearr_17196_17293[(2)] = inst_17161);

(statearr_17196_17293[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (17))){
var inst_17126 = (state_17171[(10)]);
var inst_17135 = cljs.core.first.call(null,inst_17126);
var inst_17136 = cljs.core.async.muxch_STAR_.call(null,inst_17135);
var inst_17137 = cljs.core.async.close_BANG_.call(null,inst_17136);
var inst_17138 = cljs.core.next.call(null,inst_17126);
var inst_17112 = inst_17138;
var inst_17113 = null;
var inst_17114 = (0);
var inst_17115 = (0);
var state_17171__$1 = (function (){var statearr_17197 = state_17171;
(statearr_17197[(12)] = inst_17114);

(statearr_17197[(13)] = inst_17113);

(statearr_17197[(14)] = inst_17115);

(statearr_17197[(15)] = inst_17112);

(statearr_17197[(16)] = inst_17137);

return statearr_17197;
})();
var statearr_17199_17300 = state_17171__$1;
(statearr_17199_17300[(2)] = null);

(statearr_17199_17300[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (3))){
var inst_17169 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17171__$1,inst_17169);
} else {
if((state_val_17172 === (12))){
var inst_17146 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17205_17305 = state_17171__$1;
(statearr_17205_17305[(2)] = inst_17146);

(statearr_17205_17305[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (2))){
var state_17171__$1 = state_17171;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17171__$1,(4),ch);
} else {
if((state_val_17172 === (23))){
var state_17171__$1 = state_17171;
var statearr_17206_17318 = state_17171__$1;
(statearr_17206_17318[(2)] = null);

(statearr_17206_17318[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (19))){
var inst_17102 = (state_17171[(8)]);
var inst_17152 = (state_17171[(11)]);
var inst_17154 = cljs.core.async.muxch_STAR_.call(null,inst_17152);
var state_17171__$1 = state_17171;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17171__$1,(22),inst_17154,inst_17102);
} else {
if((state_val_17172 === (11))){
var inst_17126 = (state_17171[(10)]);
var inst_17112 = (state_17171[(15)]);
var inst_17126__$1 = cljs.core.seq.call(null,inst_17112);
var state_17171__$1 = (function (){var statearr_17207 = state_17171;
(statearr_17207[(10)] = inst_17126__$1);

return statearr_17207;
})();
if(inst_17126__$1){
var statearr_17208_17321 = state_17171__$1;
(statearr_17208_17321[(1)] = (13));

} else {
var statearr_17209_17322 = state_17171__$1;
(statearr_17209_17322[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (9))){
var inst_17148 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17210_17323 = state_17171__$1;
(statearr_17210_17323[(2)] = inst_17148);

(statearr_17210_17323[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (5))){
var inst_17109 = cljs.core.deref.call(null,mults);
var inst_17110 = cljs.core.vals.call(null,inst_17109);
var inst_17111 = cljs.core.seq.call(null,inst_17110);
var inst_17112 = inst_17111;
var inst_17113 = null;
var inst_17114 = (0);
var inst_17115 = (0);
var state_17171__$1 = (function (){var statearr_17214 = state_17171;
(statearr_17214[(12)] = inst_17114);

(statearr_17214[(13)] = inst_17113);

(statearr_17214[(14)] = inst_17115);

(statearr_17214[(15)] = inst_17112);

return statearr_17214;
})();
var statearr_17215_17330 = state_17171__$1;
(statearr_17215_17330[(2)] = null);

(statearr_17215_17330[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (14))){
var state_17171__$1 = state_17171;
var statearr_17219_17331 = state_17171__$1;
(statearr_17219_17331[(2)] = null);

(statearr_17219_17331[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (16))){
var inst_17126 = (state_17171[(10)]);
var inst_17130 = cljs.core.chunk_first.call(null,inst_17126);
var inst_17131 = cljs.core.chunk_rest.call(null,inst_17126);
var inst_17132 = cljs.core.count.call(null,inst_17130);
var inst_17112 = inst_17131;
var inst_17113 = inst_17130;
var inst_17114 = inst_17132;
var inst_17115 = (0);
var state_17171__$1 = (function (){var statearr_17223 = state_17171;
(statearr_17223[(12)] = inst_17114);

(statearr_17223[(13)] = inst_17113);

(statearr_17223[(14)] = inst_17115);

(statearr_17223[(15)] = inst_17112);

return statearr_17223;
})();
var statearr_17224_17332 = state_17171__$1;
(statearr_17224_17332[(2)] = null);

(statearr_17224_17332[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (10))){
var inst_17114 = (state_17171[(12)]);
var inst_17113 = (state_17171[(13)]);
var inst_17115 = (state_17171[(14)]);
var inst_17112 = (state_17171[(15)]);
var inst_17120 = cljs.core._nth.call(null,inst_17113,inst_17115);
var inst_17121 = cljs.core.async.muxch_STAR_.call(null,inst_17120);
var inst_17122 = cljs.core.async.close_BANG_.call(null,inst_17121);
var inst_17123 = (inst_17115 + (1));
var tmp17216 = inst_17114;
var tmp17217 = inst_17113;
var tmp17218 = inst_17112;
var inst_17112__$1 = tmp17218;
var inst_17113__$1 = tmp17217;
var inst_17114__$1 = tmp17216;
var inst_17115__$1 = inst_17123;
var state_17171__$1 = (function (){var statearr_17225 = state_17171;
(statearr_17225[(12)] = inst_17114__$1);

(statearr_17225[(13)] = inst_17113__$1);

(statearr_17225[(14)] = inst_17115__$1);

(statearr_17225[(15)] = inst_17112__$1);

(statearr_17225[(17)] = inst_17122);

return statearr_17225;
})();
var statearr_17226_17345 = state_17171__$1;
(statearr_17226_17345[(2)] = null);

(statearr_17226_17345[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (18))){
var inst_17141 = (state_17171[(2)]);
var state_17171__$1 = state_17171;
var statearr_17227_17346 = state_17171__$1;
(statearr_17227_17346[(2)] = inst_17141);

(statearr_17227_17346[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17172 === (8))){
var inst_17114 = (state_17171[(12)]);
var inst_17115 = (state_17171[(14)]);
var inst_17117 = (inst_17115 < inst_17114);
var inst_17118 = inst_17117;
var state_17171__$1 = state_17171;
if(cljs.core.truth_(inst_17118)){
var statearr_17228_17349 = state_17171__$1;
(statearr_17228_17349[(1)] = (10));

} else {
var statearr_17229_17350 = state_17171__$1;
(statearr_17229_17350[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___17256,mults,ensure_mult,p))
;
return ((function (switch__13839__auto__,c__13855__auto___17256,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_17235 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17235[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_17235[(1)] = (1));

return statearr_17235;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_17171){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_17171);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e17236){if((e17236 instanceof Object)){
var ex__13843__auto__ = e17236;
var statearr_17239_17357 = state_17171;
(statearr_17239_17357[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17171);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17236;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17358 = state_17171;
state_17171 = G__17358;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_17171){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_17171);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___17256,mults,ensure_mult,p))
})();
var state__13857__auto__ = (function (){var statearr_17240 = f__13856__auto__.call(null);
(statearr_17240[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___17256);

return statearr_17240;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___17256,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var args17359 = [];
var len__7651__auto___17362 = arguments.length;
var i__7652__auto___17363 = (0);
while(true){
if((i__7652__auto___17363 < len__7651__auto___17362)){
args17359.push((arguments[i__7652__auto___17363]));

var G__17364 = (i__7652__auto___17363 + (1));
i__7652__auto___17363 = G__17364;
continue;
} else {
}
break;
}

var G__17361 = args17359.length;
switch (G__17361) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17359.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var args17367 = [];
var len__7651__auto___17373 = arguments.length;
var i__7652__auto___17374 = (0);
while(true){
if((i__7652__auto___17374 < len__7651__auto___17373)){
args17367.push((arguments[i__7652__auto___17374]));

var G__17375 = (i__7652__auto___17374 + (1));
i__7652__auto___17374 = G__17375;
continue;
} else {
}
break;
}

var G__17369 = args17367.length;
switch (G__17369) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17367.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var args17380 = [];
var len__7651__auto___17470 = arguments.length;
var i__7652__auto___17474 = (0);
while(true){
if((i__7652__auto___17474 < len__7651__auto___17470)){
args17380.push((arguments[i__7652__auto___17474]));

var G__17475 = (i__7652__auto___17474 + (1));
i__7652__auto___17474 = G__17475;
continue;
} else {
}
break;
}

var G__17382 = args17380.length;
switch (G__17382) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17380.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__13855__auto___17489 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_17429){
var state_val_17430 = (state_17429[(1)]);
if((state_val_17430 === (7))){
var state_17429__$1 = state_17429;
var statearr_17431_17490 = state_17429__$1;
(statearr_17431_17490[(2)] = null);

(statearr_17431_17490[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (1))){
var state_17429__$1 = state_17429;
var statearr_17432_17491 = state_17429__$1;
(statearr_17432_17491[(2)] = null);

(statearr_17432_17491[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (4))){
var inst_17389 = (state_17429[(7)]);
var inst_17391 = (inst_17389 < cnt);
var state_17429__$1 = state_17429;
if(cljs.core.truth_(inst_17391)){
var statearr_17433_17492 = state_17429__$1;
(statearr_17433_17492[(1)] = (6));

} else {
var statearr_17434_17505 = state_17429__$1;
(statearr_17434_17505[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (15))){
var inst_17425 = (state_17429[(2)]);
var state_17429__$1 = state_17429;
var statearr_17435_17506 = state_17429__$1;
(statearr_17435_17506[(2)] = inst_17425);

(statearr_17435_17506[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (13))){
var inst_17418 = cljs.core.async.close_BANG_.call(null,out);
var state_17429__$1 = state_17429;
var statearr_17436_17507 = state_17429__$1;
(statearr_17436_17507[(2)] = inst_17418);

(statearr_17436_17507[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (6))){
var state_17429__$1 = state_17429;
var statearr_17437_17508 = state_17429__$1;
(statearr_17437_17508[(2)] = null);

(statearr_17437_17508[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (3))){
var inst_17427 = (state_17429[(2)]);
var state_17429__$1 = state_17429;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17429__$1,inst_17427);
} else {
if((state_val_17430 === (12))){
var inst_17415 = (state_17429[(8)]);
var inst_17415__$1 = (state_17429[(2)]);
var inst_17416 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_17415__$1);
var state_17429__$1 = (function (){var statearr_17444 = state_17429;
(statearr_17444[(8)] = inst_17415__$1);

return statearr_17444;
})();
if(cljs.core.truth_(inst_17416)){
var statearr_17445_17509 = state_17429__$1;
(statearr_17445_17509[(1)] = (13));

} else {
var statearr_17446_17510 = state_17429__$1;
(statearr_17446_17510[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (2))){
var inst_17388 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_17389 = (0);
var state_17429__$1 = (function (){var statearr_17447 = state_17429;
(statearr_17447[(9)] = inst_17388);

(statearr_17447[(7)] = inst_17389);

return statearr_17447;
})();
var statearr_17448_17511 = state_17429__$1;
(statearr_17448_17511[(2)] = null);

(statearr_17448_17511[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (11))){
var inst_17389 = (state_17429[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_17429,(10),Object,null,(9));
var inst_17402 = chs__$1.call(null,inst_17389);
var inst_17403 = done.call(null,inst_17389);
var inst_17404 = cljs.core.async.take_BANG_.call(null,inst_17402,inst_17403);
var state_17429__$1 = state_17429;
var statearr_17449_17512 = state_17429__$1;
(statearr_17449_17512[(2)] = inst_17404);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17429__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (9))){
var inst_17389 = (state_17429[(7)]);
var inst_17406 = (state_17429[(2)]);
var inst_17407 = (inst_17389 + (1));
var inst_17389__$1 = inst_17407;
var state_17429__$1 = (function (){var statearr_17450 = state_17429;
(statearr_17450[(10)] = inst_17406);

(statearr_17450[(7)] = inst_17389__$1);

return statearr_17450;
})();
var statearr_17451_17514 = state_17429__$1;
(statearr_17451_17514[(2)] = null);

(statearr_17451_17514[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (5))){
var inst_17413 = (state_17429[(2)]);
var state_17429__$1 = (function (){var statearr_17452 = state_17429;
(statearr_17452[(11)] = inst_17413);

return statearr_17452;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17429__$1,(12),dchan);
} else {
if((state_val_17430 === (14))){
var inst_17415 = (state_17429[(8)]);
var inst_17420 = cljs.core.apply.call(null,f,inst_17415);
var state_17429__$1 = state_17429;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17429__$1,(16),out,inst_17420);
} else {
if((state_val_17430 === (16))){
var inst_17422 = (state_17429[(2)]);
var state_17429__$1 = (function (){var statearr_17453 = state_17429;
(statearr_17453[(12)] = inst_17422);

return statearr_17453;
})();
var statearr_17454_17516 = state_17429__$1;
(statearr_17454_17516[(2)] = null);

(statearr_17454_17516[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (10))){
var inst_17397 = (state_17429[(2)]);
var inst_17398 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_17429__$1 = (function (){var statearr_17456 = state_17429;
(statearr_17456[(13)] = inst_17397);

return statearr_17456;
})();
var statearr_17457_17518 = state_17429__$1;
(statearr_17457_17518[(2)] = inst_17398);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17429__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17430 === (8))){
var inst_17411 = (state_17429[(2)]);
var state_17429__$1 = state_17429;
var statearr_17459_17519 = state_17429__$1;
(statearr_17459_17519[(2)] = inst_17411);

(statearr_17459_17519[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__13839__auto__,c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_17463 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17463[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_17463[(1)] = (1));

return statearr_17463;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_17429){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_17429);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e17464){if((e17464 instanceof Object)){
var ex__13843__auto__ = e17464;
var statearr_17465_17533 = state_17429;
(statearr_17465_17533[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17429);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17464;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17534 = state_17429;
state_17429 = G__17534;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_17429){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_17429);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__13857__auto__ = (function (){var statearr_17469 = f__13856__auto__.call(null);
(statearr_17469[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___17489);

return statearr_17469;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___17489,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var args17538 = [];
var len__7651__auto___17628 = arguments.length;
var i__7652__auto___17629 = (0);
while(true){
if((i__7652__auto___17629 < len__7651__auto___17628)){
args17538.push((arguments[i__7652__auto___17629]));

var G__17630 = (i__7652__auto___17629 + (1));
i__7652__auto___17629 = G__17630;
continue;
} else {
}
break;
}

var G__17540 = args17538.length;
switch (G__17540) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17538.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___17632 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___17632,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___17632,out){
return (function (state_17572){
var state_val_17573 = (state_17572[(1)]);
if((state_val_17573 === (7))){
var inst_17552 = (state_17572[(7)]);
var inst_17551 = (state_17572[(8)]);
var inst_17551__$1 = (state_17572[(2)]);
var inst_17552__$1 = cljs.core.nth.call(null,inst_17551__$1,(0),null);
var inst_17553 = cljs.core.nth.call(null,inst_17551__$1,(1),null);
var inst_17554 = (inst_17552__$1 == null);
var state_17572__$1 = (function (){var statearr_17577 = state_17572;
(statearr_17577[(7)] = inst_17552__$1);

(statearr_17577[(9)] = inst_17553);

(statearr_17577[(8)] = inst_17551__$1);

return statearr_17577;
})();
if(cljs.core.truth_(inst_17554)){
var statearr_17585_17644 = state_17572__$1;
(statearr_17585_17644[(1)] = (8));

} else {
var statearr_17586_17665 = state_17572__$1;
(statearr_17586_17665[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (1))){
var inst_17541 = cljs.core.vec.call(null,chs);
var inst_17542 = inst_17541;
var state_17572__$1 = (function (){var statearr_17590 = state_17572;
(statearr_17590[(10)] = inst_17542);

return statearr_17590;
})();
var statearr_17591_17666 = state_17572__$1;
(statearr_17591_17666[(2)] = null);

(statearr_17591_17666[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (4))){
var inst_17542 = (state_17572[(10)]);
var state_17572__$1 = state_17572;
return cljs.core.async.ioc_alts_BANG_.call(null,state_17572__$1,(7),inst_17542);
} else {
if((state_val_17573 === (6))){
var inst_17568 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
var statearr_17595_17667 = state_17572__$1;
(statearr_17595_17667[(2)] = inst_17568);

(statearr_17595_17667[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (3))){
var inst_17570 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17572__$1,inst_17570);
} else {
if((state_val_17573 === (2))){
var inst_17542 = (state_17572[(10)]);
var inst_17544 = cljs.core.count.call(null,inst_17542);
var inst_17545 = (inst_17544 > (0));
var state_17572__$1 = state_17572;
if(cljs.core.truth_(inst_17545)){
var statearr_17597_17678 = state_17572__$1;
(statearr_17597_17678[(1)] = (4));

} else {
var statearr_17598_17684 = state_17572__$1;
(statearr_17598_17684[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (11))){
var inst_17542 = (state_17572[(10)]);
var inst_17561 = (state_17572[(2)]);
var tmp17596 = inst_17542;
var inst_17542__$1 = tmp17596;
var state_17572__$1 = (function (){var statearr_17599 = state_17572;
(statearr_17599[(10)] = inst_17542__$1);

(statearr_17599[(11)] = inst_17561);

return statearr_17599;
})();
var statearr_17600_17687 = state_17572__$1;
(statearr_17600_17687[(2)] = null);

(statearr_17600_17687[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (9))){
var inst_17552 = (state_17572[(7)]);
var state_17572__$1 = state_17572;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17572__$1,(11),out,inst_17552);
} else {
if((state_val_17573 === (5))){
var inst_17566 = cljs.core.async.close_BANG_.call(null,out);
var state_17572__$1 = state_17572;
var statearr_17601_17701 = state_17572__$1;
(statearr_17601_17701[(2)] = inst_17566);

(statearr_17601_17701[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (10))){
var inst_17564 = (state_17572[(2)]);
var state_17572__$1 = state_17572;
var statearr_17602_17702 = state_17572__$1;
(statearr_17602_17702[(2)] = inst_17564);

(statearr_17602_17702[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17573 === (8))){
var inst_17542 = (state_17572[(10)]);
var inst_17552 = (state_17572[(7)]);
var inst_17553 = (state_17572[(9)]);
var inst_17551 = (state_17572[(8)]);
var inst_17556 = (function (){var cs = inst_17542;
var vec__17547 = inst_17551;
var v = inst_17552;
var c = inst_17553;
return ((function (cs,vec__17547,v,c,inst_17542,inst_17552,inst_17553,inst_17551,state_val_17573,c__13855__auto___17632,out){
return (function (p1__17537_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__17537_SHARP_);
});
;})(cs,vec__17547,v,c,inst_17542,inst_17552,inst_17553,inst_17551,state_val_17573,c__13855__auto___17632,out))
})();
var inst_17557 = cljs.core.filterv.call(null,inst_17556,inst_17542);
var inst_17542__$1 = inst_17557;
var state_17572__$1 = (function (){var statearr_17603 = state_17572;
(statearr_17603[(10)] = inst_17542__$1);

return statearr_17603;
})();
var statearr_17604_17710 = state_17572__$1;
(statearr_17604_17710[(2)] = null);

(statearr_17604_17710[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___17632,out))
;
return ((function (switch__13839__auto__,c__13855__auto___17632,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_17624 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_17624[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_17624[(1)] = (1));

return statearr_17624;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_17572){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_17572);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e17625){if((e17625 instanceof Object)){
var ex__13843__auto__ = e17625;
var statearr_17626_17717 = state_17572;
(statearr_17626_17717[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17572);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17625;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17718 = state_17572;
state_17572 = G__17718;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_17572){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_17572);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___17632,out))
})();
var state__13857__auto__ = (function (){var statearr_17627 = f__13856__auto__.call(null);
(statearr_17627[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___17632);

return statearr_17627;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___17632,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var args17737 = [];
var len__7651__auto___17799 = arguments.length;
var i__7652__auto___17800 = (0);
while(true){
if((i__7652__auto___17800 < len__7651__auto___17799)){
args17737.push((arguments[i__7652__auto___17800]));

var G__17801 = (i__7652__auto___17800 + (1));
i__7652__auto___17800 = G__17801;
continue;
} else {
}
break;
}

var G__17739 = args17737.length;
switch (G__17739) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17737.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___17809 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___17809,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___17809,out){
return (function (state_17763){
var state_val_17764 = (state_17763[(1)]);
if((state_val_17764 === (7))){
var inst_17745 = (state_17763[(7)]);
var inst_17745__$1 = (state_17763[(2)]);
var inst_17746 = (inst_17745__$1 == null);
var inst_17747 = cljs.core.not.call(null,inst_17746);
var state_17763__$1 = (function (){var statearr_17765 = state_17763;
(statearr_17765[(7)] = inst_17745__$1);

return statearr_17765;
})();
if(inst_17747){
var statearr_17766_17818 = state_17763__$1;
(statearr_17766_17818[(1)] = (8));

} else {
var statearr_17767_17819 = state_17763__$1;
(statearr_17767_17819[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (1))){
var inst_17740 = (0);
var state_17763__$1 = (function (){var statearr_17768 = state_17763;
(statearr_17768[(8)] = inst_17740);

return statearr_17768;
})();
var statearr_17769_17820 = state_17763__$1;
(statearr_17769_17820[(2)] = null);

(statearr_17769_17820[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (4))){
var state_17763__$1 = state_17763;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_17763__$1,(7),ch);
} else {
if((state_val_17764 === (6))){
var inst_17758 = (state_17763[(2)]);
var state_17763__$1 = state_17763;
var statearr_17771_17821 = state_17763__$1;
(statearr_17771_17821[(2)] = inst_17758);

(statearr_17771_17821[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (3))){
var inst_17760 = (state_17763[(2)]);
var inst_17761 = cljs.core.async.close_BANG_.call(null,out);
var state_17763__$1 = (function (){var statearr_17772 = state_17763;
(statearr_17772[(9)] = inst_17760);

return statearr_17772;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_17763__$1,inst_17761);
} else {
if((state_val_17764 === (2))){
var inst_17740 = (state_17763[(8)]);
var inst_17742 = (inst_17740 < n);
var state_17763__$1 = state_17763;
if(cljs.core.truth_(inst_17742)){
var statearr_17773_17831 = state_17763__$1;
(statearr_17773_17831[(1)] = (4));

} else {
var statearr_17774_17832 = state_17763__$1;
(statearr_17774_17832[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (11))){
var inst_17740 = (state_17763[(8)]);
var inst_17750 = (state_17763[(2)]);
var inst_17751 = (inst_17740 + (1));
var inst_17740__$1 = inst_17751;
var state_17763__$1 = (function (){var statearr_17775 = state_17763;
(statearr_17775[(10)] = inst_17750);

(statearr_17775[(8)] = inst_17740__$1);

return statearr_17775;
})();
var statearr_17776_17842 = state_17763__$1;
(statearr_17776_17842[(2)] = null);

(statearr_17776_17842[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (9))){
var state_17763__$1 = state_17763;
var statearr_17777_17843 = state_17763__$1;
(statearr_17777_17843[(2)] = null);

(statearr_17777_17843[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (5))){
var state_17763__$1 = state_17763;
var statearr_17778_17844 = state_17763__$1;
(statearr_17778_17844[(2)] = null);

(statearr_17778_17844[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (10))){
var inst_17755 = (state_17763[(2)]);
var state_17763__$1 = state_17763;
var statearr_17783_17845 = state_17763__$1;
(statearr_17783_17845[(2)] = inst_17755);

(statearr_17783_17845[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17764 === (8))){
var inst_17745 = (state_17763[(7)]);
var state_17763__$1 = state_17763;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_17763__$1,(11),out,inst_17745);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___17809,out))
;
return ((function (switch__13839__auto__,c__13855__auto___17809,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_17791 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_17791[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_17791[(1)] = (1));

return statearr_17791;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_17763){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_17763);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e17792){if((e17792 instanceof Object)){
var ex__13843__auto__ = e17792;
var statearr_17794_17846 = state_17763;
(statearr_17794_17846[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_17763);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e17792;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17850 = state_17763;
state_17763 = G__17850;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_17763){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_17763);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___17809,out))
})();
var state__13857__auto__ = (function (){var statearr_17798 = f__13856__auto__.call(null);
(statearr_17798[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___17809);

return statearr_17798;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___17809,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async17879 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17879 = (function (f,ch,meta17880){
this.f = f;
this.ch = ch;
this.meta17880 = meta17880;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17881,meta17880__$1){
var self__ = this;
var _17881__$1 = this;
return (new cljs.core.async.t_cljs$core$async17879(self__.f,self__.ch,meta17880__$1));
});

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17881){
var self__ = this;
var _17881__$1 = this;
return self__.meta17880;
});

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async17886 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17886 = (function (f,ch,meta17880,_,fn1,meta17887){
this.f = f;
this.ch = ch;
this.meta17880 = meta17880;
this._ = _;
this.fn1 = fn1;
this.meta17887 = meta17887;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_17888,meta17887__$1){
var self__ = this;
var _17888__$1 = this;
return (new cljs.core.async.t_cljs$core$async17886(self__.f,self__.ch,self__.meta17880,self__._,self__.fn1,meta17887__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_17888){
var self__ = this;
var _17888__$1 = this;
return self__.meta17887;
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__17851_SHARP_){
return f1.call(null,(((p1__17851_SHARP_ == null))?null:self__.f.call(null,p1__17851_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17880","meta17880",-1663208500,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async17879","cljs.core.async/t_cljs$core$async17879",198679428,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta17887","meta17887",1090982595,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async17886.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17886.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17886";

cljs.core.async.t_cljs$core$async17886.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17886");
});})(___$1))
;

cljs.core.async.__GT_t_cljs$core$async17886 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async17886(f__$1,ch__$1,meta17880__$1,___$2,fn1__$1,meta17887){
return (new cljs.core.async.t_cljs$core$async17886(f__$1,ch__$1,meta17880__$1,___$2,fn1__$1,meta17887));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async17886(self__.f,self__.ch,self__.meta17880,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__6531__auto__ = ret;
if(cljs.core.truth_(and__6531__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__6531__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17879.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async17879.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17880","meta17880",-1663208500,null)], null);
});

cljs.core.async.t_cljs$core$async17879.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17879.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17879";

cljs.core.async.t_cljs$core$async17879.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17879");
});

cljs.core.async.__GT_t_cljs$core$async17879 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async17879(f__$1,ch__$1,meta17880){
return (new cljs.core.async.t_cljs$core$async17879(f__$1,ch__$1,meta17880));
});

}

return (new cljs.core.async.t_cljs$core$async17879(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async17942 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17942 = (function (f,ch,meta17943){
this.f = f;
this.ch = ch;
this.meta17943 = meta17943;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17944,meta17943__$1){
var self__ = this;
var _17944__$1 = this;
return (new cljs.core.async.t_cljs$core$async17942(self__.f,self__.ch,meta17943__$1));
});

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17944){
var self__ = this;
var _17944__$1 = this;
return self__.meta17943;
});

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17942.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async17942.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17943","meta17943",-1086888824,null)], null);
});

cljs.core.async.t_cljs$core$async17942.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17942.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17942";

cljs.core.async.t_cljs$core$async17942.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17942");
});

cljs.core.async.__GT_t_cljs$core$async17942 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async17942(f__$1,ch__$1,meta17943){
return (new cljs.core.async.t_cljs$core$async17942(f__$1,ch__$1,meta17943));
});

}

return (new cljs.core.async.t_cljs$core$async17942(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async17991 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async17991 = (function (p,ch,meta17992){
this.p = p;
this.ch = ch;
this.meta17992 = meta17992;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
})
cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_17993,meta17992__$1){
var self__ = this;
var _17993__$1 = this;
return (new cljs.core.async.t_cljs$core$async17991(self__.p,self__.ch,meta17992__$1));
});

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_17993){
var self__ = this;
var _17993__$1 = this;
return self__.meta17992;
});

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async17991.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async17991.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta17992","meta17992",1613661468,null)], null);
});

cljs.core.async.t_cljs$core$async17991.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async17991.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async17991";

cljs.core.async.t_cljs$core$async17991.cljs$lang$ctorPrWriter = (function (this__7149__auto__,writer__7150__auto__,opt__7151__auto__){
return cljs.core._write.call(null,writer__7150__auto__,"cljs.core.async/t_cljs$core$async17991");
});

cljs.core.async.__GT_t_cljs$core$async17991 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async17991(p__$1,ch__$1,meta17992){
return (new cljs.core.async.t_cljs$core$async17991(p__$1,ch__$1,meta17992));
});

}

return (new cljs.core.async.t_cljs$core$async17991(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var args17995 = [];
var len__7651__auto___18062 = arguments.length;
var i__7652__auto___18064 = (0);
while(true){
if((i__7652__auto___18064 < len__7651__auto___18062)){
args17995.push((arguments[i__7652__auto___18064]));

var G__18065 = (i__7652__auto___18064 + (1));
i__7652__auto___18064 = G__18065;
continue;
} else {
}
break;
}

var G__17997 = args17995.length;
switch (G__17997) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args17995.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___18075 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___18075,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___18075,out){
return (function (state_18028){
var state_val_18029 = (state_18028[(1)]);
if((state_val_18029 === (7))){
var inst_18023 = (state_18028[(2)]);
var state_18028__$1 = state_18028;
var statearr_18034_18083 = state_18028__$1;
(statearr_18034_18083[(2)] = inst_18023);

(statearr_18034_18083[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (1))){
var state_18028__$1 = state_18028;
var statearr_18035_18084 = state_18028__$1;
(statearr_18035_18084[(2)] = null);

(statearr_18035_18084[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (4))){
var inst_18005 = (state_18028[(7)]);
var inst_18005__$1 = (state_18028[(2)]);
var inst_18006 = (inst_18005__$1 == null);
var state_18028__$1 = (function (){var statearr_18036 = state_18028;
(statearr_18036[(7)] = inst_18005__$1);

return statearr_18036;
})();
if(cljs.core.truth_(inst_18006)){
var statearr_18037_18086 = state_18028__$1;
(statearr_18037_18086[(1)] = (5));

} else {
var statearr_18038_18088 = state_18028__$1;
(statearr_18038_18088[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (6))){
var inst_18005 = (state_18028[(7)]);
var inst_18010 = p.call(null,inst_18005);
var state_18028__$1 = state_18028;
if(cljs.core.truth_(inst_18010)){
var statearr_18039_18091 = state_18028__$1;
(statearr_18039_18091[(1)] = (8));

} else {
var statearr_18040_18092 = state_18028__$1;
(statearr_18040_18092[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (3))){
var inst_18025 = (state_18028[(2)]);
var state_18028__$1 = state_18028;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18028__$1,inst_18025);
} else {
if((state_val_18029 === (2))){
var state_18028__$1 = state_18028;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18028__$1,(4),ch);
} else {
if((state_val_18029 === (11))){
var inst_18013 = (state_18028[(2)]);
var state_18028__$1 = state_18028;
var statearr_18041_18093 = state_18028__$1;
(statearr_18041_18093[(2)] = inst_18013);

(statearr_18041_18093[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (9))){
var state_18028__$1 = state_18028;
var statearr_18042_18094 = state_18028__$1;
(statearr_18042_18094[(2)] = null);

(statearr_18042_18094[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (5))){
var inst_18008 = cljs.core.async.close_BANG_.call(null,out);
var state_18028__$1 = state_18028;
var statearr_18043_18095 = state_18028__$1;
(statearr_18043_18095[(2)] = inst_18008);

(statearr_18043_18095[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (10))){
var inst_18018 = (state_18028[(2)]);
var state_18028__$1 = (function (){var statearr_18044 = state_18028;
(statearr_18044[(8)] = inst_18018);

return statearr_18044;
})();
var statearr_18045_18096 = state_18028__$1;
(statearr_18045_18096[(2)] = null);

(statearr_18045_18096[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18029 === (8))){
var inst_18005 = (state_18028[(7)]);
var state_18028__$1 = state_18028;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18028__$1,(11),out,inst_18005);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___18075,out))
;
return ((function (switch__13839__auto__,c__13855__auto___18075,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_18053 = [null,null,null,null,null,null,null,null,null];
(statearr_18053[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_18053[(1)] = (1));

return statearr_18053;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_18028){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_18028);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e18055){if((e18055 instanceof Object)){
var ex__13843__auto__ = e18055;
var statearr_18056_18113 = state_18028;
(statearr_18056_18113[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18028);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18055;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18118 = state_18028;
state_18028 = G__18118;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_18028){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_18028);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___18075,out))
})();
var state__13857__auto__ = (function (){var statearr_18058 = f__13856__auto__.call(null);
(statearr_18058[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___18075);

return statearr_18058;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___18075,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var args18119 = [];
var len__7651__auto___18126 = arguments.length;
var i__7652__auto___18127 = (0);
while(true){
if((i__7652__auto___18127 < len__7651__auto___18126)){
args18119.push((arguments[i__7652__auto___18127]));

var G__18128 = (i__7652__auto___18127 + (1));
i__7652__auto___18127 = G__18128;
continue;
} else {
}
break;
}

var G__18121 = args18119.length;
switch (G__18121) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18119.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__13855__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto__){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto__){
return (function (state_18331){
var state_val_18332 = (state_18331[(1)]);
if((state_val_18332 === (7))){
var inst_18327 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
var statearr_18333_18419 = state_18331__$1;
(statearr_18333_18419[(2)] = inst_18327);

(statearr_18333_18419[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (20))){
var inst_18297 = (state_18331[(7)]);
var inst_18308 = (state_18331[(2)]);
var inst_18309 = cljs.core.next.call(null,inst_18297);
var inst_18283 = inst_18309;
var inst_18284 = null;
var inst_18285 = (0);
var inst_18286 = (0);
var state_18331__$1 = (function (){var statearr_18338 = state_18331;
(statearr_18338[(8)] = inst_18286);

(statearr_18338[(9)] = inst_18283);

(statearr_18338[(10)] = inst_18285);

(statearr_18338[(11)] = inst_18308);

(statearr_18338[(12)] = inst_18284);

return statearr_18338;
})();
var statearr_18339_18431 = state_18331__$1;
(statearr_18339_18431[(2)] = null);

(statearr_18339_18431[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (1))){
var state_18331__$1 = state_18331;
var statearr_18344_18432 = state_18331__$1;
(statearr_18344_18432[(2)] = null);

(statearr_18344_18432[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (4))){
var inst_18272 = (state_18331[(13)]);
var inst_18272__$1 = (state_18331[(2)]);
var inst_18273 = (inst_18272__$1 == null);
var state_18331__$1 = (function (){var statearr_18345 = state_18331;
(statearr_18345[(13)] = inst_18272__$1);

return statearr_18345;
})();
if(cljs.core.truth_(inst_18273)){
var statearr_18346_18437 = state_18331__$1;
(statearr_18346_18437[(1)] = (5));

} else {
var statearr_18347_18438 = state_18331__$1;
(statearr_18347_18438[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (15))){
var state_18331__$1 = state_18331;
var statearr_18351_18440 = state_18331__$1;
(statearr_18351_18440[(2)] = null);

(statearr_18351_18440[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (21))){
var state_18331__$1 = state_18331;
var statearr_18352_18442 = state_18331__$1;
(statearr_18352_18442[(2)] = null);

(statearr_18352_18442[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (13))){
var inst_18286 = (state_18331[(8)]);
var inst_18283 = (state_18331[(9)]);
var inst_18285 = (state_18331[(10)]);
var inst_18284 = (state_18331[(12)]);
var inst_18293 = (state_18331[(2)]);
var inst_18294 = (inst_18286 + (1));
var tmp18348 = inst_18283;
var tmp18349 = inst_18285;
var tmp18350 = inst_18284;
var inst_18283__$1 = tmp18348;
var inst_18284__$1 = tmp18350;
var inst_18285__$1 = tmp18349;
var inst_18286__$1 = inst_18294;
var state_18331__$1 = (function (){var statearr_18353 = state_18331;
(statearr_18353[(8)] = inst_18286__$1);

(statearr_18353[(9)] = inst_18283__$1);

(statearr_18353[(10)] = inst_18285__$1);

(statearr_18353[(12)] = inst_18284__$1);

(statearr_18353[(14)] = inst_18293);

return statearr_18353;
})();
var statearr_18354_18454 = state_18331__$1;
(statearr_18354_18454[(2)] = null);

(statearr_18354_18454[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (22))){
var state_18331__$1 = state_18331;
var statearr_18355_18455 = state_18331__$1;
(statearr_18355_18455[(2)] = null);

(statearr_18355_18455[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (6))){
var inst_18272 = (state_18331[(13)]);
var inst_18281 = f.call(null,inst_18272);
var inst_18282 = cljs.core.seq.call(null,inst_18281);
var inst_18283 = inst_18282;
var inst_18284 = null;
var inst_18285 = (0);
var inst_18286 = (0);
var state_18331__$1 = (function (){var statearr_18356 = state_18331;
(statearr_18356[(8)] = inst_18286);

(statearr_18356[(9)] = inst_18283);

(statearr_18356[(10)] = inst_18285);

(statearr_18356[(12)] = inst_18284);

return statearr_18356;
})();
var statearr_18357_18460 = state_18331__$1;
(statearr_18357_18460[(2)] = null);

(statearr_18357_18460[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (17))){
var inst_18297 = (state_18331[(7)]);
var inst_18301 = cljs.core.chunk_first.call(null,inst_18297);
var inst_18302 = cljs.core.chunk_rest.call(null,inst_18297);
var inst_18303 = cljs.core.count.call(null,inst_18301);
var inst_18283 = inst_18302;
var inst_18284 = inst_18301;
var inst_18285 = inst_18303;
var inst_18286 = (0);
var state_18331__$1 = (function (){var statearr_18358 = state_18331;
(statearr_18358[(8)] = inst_18286);

(statearr_18358[(9)] = inst_18283);

(statearr_18358[(10)] = inst_18285);

(statearr_18358[(12)] = inst_18284);

return statearr_18358;
})();
var statearr_18359_18470 = state_18331__$1;
(statearr_18359_18470[(2)] = null);

(statearr_18359_18470[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (3))){
var inst_18329 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18331__$1,inst_18329);
} else {
if((state_val_18332 === (12))){
var inst_18317 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
var statearr_18364_18482 = state_18331__$1;
(statearr_18364_18482[(2)] = inst_18317);

(statearr_18364_18482[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (2))){
var state_18331__$1 = state_18331;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18331__$1,(4),in$);
} else {
if((state_val_18332 === (23))){
var inst_18325 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
var statearr_18369_18487 = state_18331__$1;
(statearr_18369_18487[(2)] = inst_18325);

(statearr_18369_18487[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (19))){
var inst_18312 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
var statearr_18370_18493 = state_18331__$1;
(statearr_18370_18493[(2)] = inst_18312);

(statearr_18370_18493[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (11))){
var inst_18283 = (state_18331[(9)]);
var inst_18297 = (state_18331[(7)]);
var inst_18297__$1 = cljs.core.seq.call(null,inst_18283);
var state_18331__$1 = (function (){var statearr_18371 = state_18331;
(statearr_18371[(7)] = inst_18297__$1);

return statearr_18371;
})();
if(inst_18297__$1){
var statearr_18372_18500 = state_18331__$1;
(statearr_18372_18500[(1)] = (14));

} else {
var statearr_18373_18501 = state_18331__$1;
(statearr_18373_18501[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (9))){
var inst_18319 = (state_18331[(2)]);
var inst_18320 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_18331__$1 = (function (){var statearr_18374 = state_18331;
(statearr_18374[(15)] = inst_18319);

return statearr_18374;
})();
if(cljs.core.truth_(inst_18320)){
var statearr_18375_18504 = state_18331__$1;
(statearr_18375_18504[(1)] = (21));

} else {
var statearr_18376_18505 = state_18331__$1;
(statearr_18376_18505[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (5))){
var inst_18275 = cljs.core.async.close_BANG_.call(null,out);
var state_18331__$1 = state_18331;
var statearr_18377_18510 = state_18331__$1;
(statearr_18377_18510[(2)] = inst_18275);

(statearr_18377_18510[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (14))){
var inst_18297 = (state_18331[(7)]);
var inst_18299 = cljs.core.chunked_seq_QMARK_.call(null,inst_18297);
var state_18331__$1 = state_18331;
if(inst_18299){
var statearr_18378_18511 = state_18331__$1;
(statearr_18378_18511[(1)] = (17));

} else {
var statearr_18386_18512 = state_18331__$1;
(statearr_18386_18512[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (16))){
var inst_18315 = (state_18331[(2)]);
var state_18331__$1 = state_18331;
var statearr_18387_18513 = state_18331__$1;
(statearr_18387_18513[(2)] = inst_18315);

(statearr_18387_18513[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18332 === (10))){
var inst_18286 = (state_18331[(8)]);
var inst_18284 = (state_18331[(12)]);
var inst_18291 = cljs.core._nth.call(null,inst_18284,inst_18286);
var state_18331__$1 = state_18331;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18331__$1,(13),out,inst_18291);
} else {
if((state_val_18332 === (18))){
var inst_18297 = (state_18331[(7)]);
var inst_18306 = cljs.core.first.call(null,inst_18297);
var state_18331__$1 = state_18331;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18331__$1,(20),out,inst_18306);
} else {
if((state_val_18332 === (8))){
var inst_18286 = (state_18331[(8)]);
var inst_18285 = (state_18331[(10)]);
var inst_18288 = (inst_18286 < inst_18285);
var inst_18289 = inst_18288;
var state_18331__$1 = state_18331;
if(cljs.core.truth_(inst_18289)){
var statearr_18394_18522 = state_18331__$1;
(statearr_18394_18522[(1)] = (10));

} else {
var statearr_18399_18523 = state_18331__$1;
(statearr_18399_18523[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto__))
;
return ((function (switch__13839__auto__,c__13855__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____0 = (function (){
var statearr_18409 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18409[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__);

(statearr_18409[(1)] = (1));

return statearr_18409;
});
var cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____1 = (function (state_18331){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_18331);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e18413){if((e18413 instanceof Object)){
var ex__13843__auto__ = e18413;
var statearr_18414_18537 = state_18331;
(statearr_18414_18537[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18331);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18413;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18540 = state_18331;
state_18331 = G__18540;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__ = function(state_18331){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____1.call(this,state_18331);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__13840__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto__))
})();
var state__13857__auto__ = (function (){var statearr_18415 = f__13856__auto__.call(null);
(statearr_18415[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto__);

return statearr_18415;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto__))
);

return c__13855__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var args18541 = [];
var len__7651__auto___18546 = arguments.length;
var i__7652__auto___18547 = (0);
while(true){
if((i__7652__auto___18547 < len__7651__auto___18546)){
args18541.push((arguments[i__7652__auto___18547]));

var G__18548 = (i__7652__auto___18547 + (1));
i__7652__auto___18547 = G__18548;
continue;
} else {
}
break;
}

var G__18543 = args18541.length;
switch (G__18543) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18541.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var args18550 = [];
var len__7651__auto___18586 = arguments.length;
var i__7652__auto___18587 = (0);
while(true){
if((i__7652__auto___18587 < len__7651__auto___18586)){
args18550.push((arguments[i__7652__auto___18587]));

var G__18588 = (i__7652__auto___18587 + (1));
i__7652__auto___18587 = G__18588;
continue;
} else {
}
break;
}

var G__18552 = args18550.length;
switch (G__18552) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18550.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var args18599 = [];
var len__7651__auto___18662 = arguments.length;
var i__7652__auto___18663 = (0);
while(true){
if((i__7652__auto___18663 < len__7651__auto___18662)){
args18599.push((arguments[i__7652__auto___18663]));

var G__18664 = (i__7652__auto___18663 + (1));
i__7652__auto___18663 = G__18664;
continue;
} else {
}
break;
}

var G__18601 = args18599.length;
switch (G__18601) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18599.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___18666 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___18666,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___18666,out){
return (function (state_18625){
var state_val_18626 = (state_18625[(1)]);
if((state_val_18626 === (7))){
var inst_18620 = (state_18625[(2)]);
var state_18625__$1 = state_18625;
var statearr_18627_18667 = state_18625__$1;
(statearr_18627_18667[(2)] = inst_18620);

(statearr_18627_18667[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (1))){
var inst_18602 = null;
var state_18625__$1 = (function (){var statearr_18628 = state_18625;
(statearr_18628[(7)] = inst_18602);

return statearr_18628;
})();
var statearr_18629_18671 = state_18625__$1;
(statearr_18629_18671[(2)] = null);

(statearr_18629_18671[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (4))){
var inst_18605 = (state_18625[(8)]);
var inst_18605__$1 = (state_18625[(2)]);
var inst_18606 = (inst_18605__$1 == null);
var inst_18607 = cljs.core.not.call(null,inst_18606);
var state_18625__$1 = (function (){var statearr_18630 = state_18625;
(statearr_18630[(8)] = inst_18605__$1);

return statearr_18630;
})();
if(inst_18607){
var statearr_18631_18678 = state_18625__$1;
(statearr_18631_18678[(1)] = (5));

} else {
var statearr_18632_18682 = state_18625__$1;
(statearr_18632_18682[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (6))){
var state_18625__$1 = state_18625;
var statearr_18633_18686 = state_18625__$1;
(statearr_18633_18686[(2)] = null);

(statearr_18633_18686[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (3))){
var inst_18622 = (state_18625[(2)]);
var inst_18623 = cljs.core.async.close_BANG_.call(null,out);
var state_18625__$1 = (function (){var statearr_18637 = state_18625;
(statearr_18637[(9)] = inst_18622);

return statearr_18637;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18625__$1,inst_18623);
} else {
if((state_val_18626 === (2))){
var state_18625__$1 = state_18625;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18625__$1,(4),ch);
} else {
if((state_val_18626 === (11))){
var inst_18605 = (state_18625[(8)]);
var inst_18614 = (state_18625[(2)]);
var inst_18602 = inst_18605;
var state_18625__$1 = (function (){var statearr_18639 = state_18625;
(statearr_18639[(7)] = inst_18602);

(statearr_18639[(10)] = inst_18614);

return statearr_18639;
})();
var statearr_18640_18700 = state_18625__$1;
(statearr_18640_18700[(2)] = null);

(statearr_18640_18700[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (9))){
var inst_18605 = (state_18625[(8)]);
var state_18625__$1 = state_18625;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18625__$1,(11),out,inst_18605);
} else {
if((state_val_18626 === (5))){
var inst_18602 = (state_18625[(7)]);
var inst_18605 = (state_18625[(8)]);
var inst_18609 = cljs.core._EQ_.call(null,inst_18605,inst_18602);
var state_18625__$1 = state_18625;
if(inst_18609){
var statearr_18646_18705 = state_18625__$1;
(statearr_18646_18705[(1)] = (8));

} else {
var statearr_18647_18706 = state_18625__$1;
(statearr_18647_18706[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (10))){
var inst_18617 = (state_18625[(2)]);
var state_18625__$1 = state_18625;
var statearr_18648_18707 = state_18625__$1;
(statearr_18648_18707[(2)] = inst_18617);

(statearr_18648_18707[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18626 === (8))){
var inst_18602 = (state_18625[(7)]);
var tmp18645 = inst_18602;
var inst_18602__$1 = tmp18645;
var state_18625__$1 = (function (){var statearr_18649 = state_18625;
(statearr_18649[(7)] = inst_18602__$1);

return statearr_18649;
})();
var statearr_18650_18711 = state_18625__$1;
(statearr_18650_18711[(2)] = null);

(statearr_18650_18711[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___18666,out))
;
return ((function (switch__13839__auto__,c__13855__auto___18666,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_18654 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_18654[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_18654[(1)] = (1));

return statearr_18654;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_18625){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_18625);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e18655){if((e18655 instanceof Object)){
var ex__13843__auto__ = e18655;
var statearr_18656_18712 = state_18625;
(statearr_18656_18712[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18625);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18655;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18713 = state_18625;
state_18625 = G__18713;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_18625){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_18625);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___18666,out))
})();
var state__13857__auto__ = (function (){var statearr_18657 = f__13856__auto__.call(null);
(statearr_18657[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___18666);

return statearr_18657;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___18666,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var args18714 = [];
var len__7651__auto___18820 = arguments.length;
var i__7652__auto___18821 = (0);
while(true){
if((i__7652__auto___18821 < len__7651__auto___18820)){
args18714.push((arguments[i__7652__auto___18821]));

var G__18822 = (i__7652__auto___18821 + (1));
i__7652__auto___18821 = G__18822;
continue;
} else {
}
break;
}

var G__18722 = args18714.length;
switch (G__18722) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18714.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___18829 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___18829,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___18829,out){
return (function (state_18763){
var state_val_18764 = (state_18763[(1)]);
if((state_val_18764 === (7))){
var inst_18759 = (state_18763[(2)]);
var state_18763__$1 = state_18763;
var statearr_18765_18830 = state_18763__$1;
(statearr_18765_18830[(2)] = inst_18759);

(statearr_18765_18830[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (1))){
var inst_18723 = (new Array(n));
var inst_18724 = inst_18723;
var inst_18725 = (0);
var state_18763__$1 = (function (){var statearr_18766 = state_18763;
(statearr_18766[(7)] = inst_18724);

(statearr_18766[(8)] = inst_18725);

return statearr_18766;
})();
var statearr_18770_18831 = state_18763__$1;
(statearr_18770_18831[(2)] = null);

(statearr_18770_18831[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (4))){
var inst_18728 = (state_18763[(9)]);
var inst_18728__$1 = (state_18763[(2)]);
var inst_18729 = (inst_18728__$1 == null);
var inst_18730 = cljs.core.not.call(null,inst_18729);
var state_18763__$1 = (function (){var statearr_18771 = state_18763;
(statearr_18771[(9)] = inst_18728__$1);

return statearr_18771;
})();
if(inst_18730){
var statearr_18772_18832 = state_18763__$1;
(statearr_18772_18832[(1)] = (5));

} else {
var statearr_18773_18833 = state_18763__$1;
(statearr_18773_18833[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (15))){
var inst_18753 = (state_18763[(2)]);
var state_18763__$1 = state_18763;
var statearr_18774_18834 = state_18763__$1;
(statearr_18774_18834[(2)] = inst_18753);

(statearr_18774_18834[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (13))){
var state_18763__$1 = state_18763;
var statearr_18775_18835 = state_18763__$1;
(statearr_18775_18835[(2)] = null);

(statearr_18775_18835[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (6))){
var inst_18725 = (state_18763[(8)]);
var inst_18749 = (inst_18725 > (0));
var state_18763__$1 = state_18763;
if(cljs.core.truth_(inst_18749)){
var statearr_18776_18836 = state_18763__$1;
(statearr_18776_18836[(1)] = (12));

} else {
var statearr_18777_18839 = state_18763__$1;
(statearr_18777_18839[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (3))){
var inst_18761 = (state_18763[(2)]);
var state_18763__$1 = state_18763;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18763__$1,inst_18761);
} else {
if((state_val_18764 === (12))){
var inst_18724 = (state_18763[(7)]);
var inst_18751 = cljs.core.vec.call(null,inst_18724);
var state_18763__$1 = state_18763;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18763__$1,(15),out,inst_18751);
} else {
if((state_val_18764 === (2))){
var state_18763__$1 = state_18763;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18763__$1,(4),ch);
} else {
if((state_val_18764 === (11))){
var inst_18743 = (state_18763[(2)]);
var inst_18744 = (new Array(n));
var inst_18724 = inst_18744;
var inst_18725 = (0);
var state_18763__$1 = (function (){var statearr_18785 = state_18763;
(statearr_18785[(10)] = inst_18743);

(statearr_18785[(7)] = inst_18724);

(statearr_18785[(8)] = inst_18725);

return statearr_18785;
})();
var statearr_18786_18840 = state_18763__$1;
(statearr_18786_18840[(2)] = null);

(statearr_18786_18840[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (9))){
var inst_18724 = (state_18763[(7)]);
var inst_18741 = cljs.core.vec.call(null,inst_18724);
var state_18763__$1 = state_18763;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18763__$1,(11),out,inst_18741);
} else {
if((state_val_18764 === (5))){
var inst_18733 = (state_18763[(11)]);
var inst_18728 = (state_18763[(9)]);
var inst_18724 = (state_18763[(7)]);
var inst_18725 = (state_18763[(8)]);
var inst_18732 = (inst_18724[inst_18725] = inst_18728);
var inst_18733__$1 = (inst_18725 + (1));
var inst_18734 = (inst_18733__$1 < n);
var state_18763__$1 = (function (){var statearr_18788 = state_18763;
(statearr_18788[(11)] = inst_18733__$1);

(statearr_18788[(12)] = inst_18732);

return statearr_18788;
})();
if(cljs.core.truth_(inst_18734)){
var statearr_18789_18847 = state_18763__$1;
(statearr_18789_18847[(1)] = (8));

} else {
var statearr_18790_18850 = state_18763__$1;
(statearr_18790_18850[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (14))){
var inst_18756 = (state_18763[(2)]);
var inst_18757 = cljs.core.async.close_BANG_.call(null,out);
var state_18763__$1 = (function (){var statearr_18792 = state_18763;
(statearr_18792[(13)] = inst_18756);

return statearr_18792;
})();
var statearr_18793_18858 = state_18763__$1;
(statearr_18793_18858[(2)] = inst_18757);

(statearr_18793_18858[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (10))){
var inst_18747 = (state_18763[(2)]);
var state_18763__$1 = state_18763;
var statearr_18794_18865 = state_18763__$1;
(statearr_18794_18865[(2)] = inst_18747);

(statearr_18794_18865[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18764 === (8))){
var inst_18733 = (state_18763[(11)]);
var inst_18724 = (state_18763[(7)]);
var tmp18791 = inst_18724;
var inst_18724__$1 = tmp18791;
var inst_18725 = inst_18733;
var state_18763__$1 = (function (){var statearr_18795 = state_18763;
(statearr_18795[(7)] = inst_18724__$1);

(statearr_18795[(8)] = inst_18725);

return statearr_18795;
})();
var statearr_18800_18873 = state_18763__$1;
(statearr_18800_18873[(2)] = null);

(statearr_18800_18873[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___18829,out))
;
return ((function (switch__13839__auto__,c__13855__auto___18829,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_18812 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18812[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_18812[(1)] = (1));

return statearr_18812;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_18763){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_18763);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e18813){if((e18813 instanceof Object)){
var ex__13843__auto__ = e18813;
var statearr_18814_18877 = state_18763;
(statearr_18814_18877[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18763);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18813;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__18878 = state_18763;
state_18763 = G__18878;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_18763){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_18763);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___18829,out))
})();
var state__13857__auto__ = (function (){var statearr_18815 = f__13856__auto__.call(null);
(statearr_18815[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___18829);

return statearr_18815;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___18829,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var args18883 = [];
var len__7651__auto___18982 = arguments.length;
var i__7652__auto___18983 = (0);
while(true){
if((i__7652__auto___18983 < len__7651__auto___18982)){
args18883.push((arguments[i__7652__auto___18983]));

var G__18984 = (i__7652__auto___18983 + (1));
i__7652__auto___18983 = G__18984;
continue;
} else {
}
break;
}

var G__18888 = args18883.length;
switch (G__18888) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error([cljs.core.str("Invalid arity: "),cljs.core.str(args18883.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__13855__auto___18986 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__13855__auto___18986,out){
return (function (){
var f__13856__auto__ = (function (){var switch__13839__auto__ = ((function (c__13855__auto___18986,out){
return (function (state_18937){
var state_val_18942 = (state_18937[(1)]);
if((state_val_18942 === (7))){
var inst_18932 = (state_18937[(2)]);
var state_18937__$1 = state_18937;
var statearr_18943_18987 = state_18937__$1;
(statearr_18943_18987[(2)] = inst_18932);

(statearr_18943_18987[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (1))){
var inst_18893 = [];
var inst_18894 = inst_18893;
var inst_18895 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_18937__$1 = (function (){var statearr_18947 = state_18937;
(statearr_18947[(7)] = inst_18894);

(statearr_18947[(8)] = inst_18895);

return statearr_18947;
})();
var statearr_18948_18988 = state_18937__$1;
(statearr_18948_18988[(2)] = null);

(statearr_18948_18988[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (4))){
var inst_18898 = (state_18937[(9)]);
var inst_18898__$1 = (state_18937[(2)]);
var inst_18899 = (inst_18898__$1 == null);
var inst_18900 = cljs.core.not.call(null,inst_18899);
var state_18937__$1 = (function (){var statearr_18949 = state_18937;
(statearr_18949[(9)] = inst_18898__$1);

return statearr_18949;
})();
if(inst_18900){
var statearr_18950_18989 = state_18937__$1;
(statearr_18950_18989[(1)] = (5));

} else {
var statearr_18951_18991 = state_18937__$1;
(statearr_18951_18991[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (15))){
var inst_18926 = (state_18937[(2)]);
var state_18937__$1 = state_18937;
var statearr_18956_18997 = state_18937__$1;
(statearr_18956_18997[(2)] = inst_18926);

(statearr_18956_18997[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (13))){
var state_18937__$1 = state_18937;
var statearr_18957_18999 = state_18937__$1;
(statearr_18957_18999[(2)] = null);

(statearr_18957_18999[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (6))){
var inst_18894 = (state_18937[(7)]);
var inst_18921 = inst_18894.length;
var inst_18922 = (inst_18921 > (0));
var state_18937__$1 = state_18937;
if(cljs.core.truth_(inst_18922)){
var statearr_18958_19010 = state_18937__$1;
(statearr_18958_19010[(1)] = (12));

} else {
var statearr_18959_19011 = state_18937__$1;
(statearr_18959_19011[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (3))){
var inst_18935 = (state_18937[(2)]);
var state_18937__$1 = state_18937;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_18937__$1,inst_18935);
} else {
if((state_val_18942 === (12))){
var inst_18894 = (state_18937[(7)]);
var inst_18924 = cljs.core.vec.call(null,inst_18894);
var state_18937__$1 = state_18937;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18937__$1,(15),out,inst_18924);
} else {
if((state_val_18942 === (2))){
var state_18937__$1 = state_18937;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_18937__$1,(4),ch);
} else {
if((state_val_18942 === (11))){
var inst_18898 = (state_18937[(9)]);
var inst_18902 = (state_18937[(10)]);
var inst_18913 = (state_18937[(2)]);
var inst_18915 = [];
var inst_18916 = inst_18915.push(inst_18898);
var inst_18894 = inst_18915;
var inst_18895 = inst_18902;
var state_18937__$1 = (function (){var statearr_18960 = state_18937;
(statearr_18960[(7)] = inst_18894);

(statearr_18960[(11)] = inst_18913);

(statearr_18960[(12)] = inst_18916);

(statearr_18960[(8)] = inst_18895);

return statearr_18960;
})();
var statearr_18962_19028 = state_18937__$1;
(statearr_18962_19028[(2)] = null);

(statearr_18962_19028[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (9))){
var inst_18894 = (state_18937[(7)]);
var inst_18911 = cljs.core.vec.call(null,inst_18894);
var state_18937__$1 = state_18937;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_18937__$1,(11),out,inst_18911);
} else {
if((state_val_18942 === (5))){
var inst_18898 = (state_18937[(9)]);
var inst_18902 = (state_18937[(10)]);
var inst_18895 = (state_18937[(8)]);
var inst_18902__$1 = f.call(null,inst_18898);
var inst_18904 = cljs.core._EQ_.call(null,inst_18902__$1,inst_18895);
var inst_18905 = cljs.core.keyword_identical_QMARK_.call(null,inst_18895,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_18906 = (inst_18904) || (inst_18905);
var state_18937__$1 = (function (){var statearr_18964 = state_18937;
(statearr_18964[(10)] = inst_18902__$1);

return statearr_18964;
})();
if(cljs.core.truth_(inst_18906)){
var statearr_18965_19035 = state_18937__$1;
(statearr_18965_19035[(1)] = (8));

} else {
var statearr_18966_19036 = state_18937__$1;
(statearr_18966_19036[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (14))){
var inst_18929 = (state_18937[(2)]);
var inst_18930 = cljs.core.async.close_BANG_.call(null,out);
var state_18937__$1 = (function (){var statearr_18970 = state_18937;
(statearr_18970[(13)] = inst_18929);

return statearr_18970;
})();
var statearr_18971_19037 = state_18937__$1;
(statearr_18971_19037[(2)] = inst_18930);

(statearr_18971_19037[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (10))){
var inst_18919 = (state_18937[(2)]);
var state_18937__$1 = state_18937;
var statearr_18972_19038 = state_18937__$1;
(statearr_18972_19038[(2)] = inst_18919);

(statearr_18972_19038[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_18942 === (8))){
var inst_18898 = (state_18937[(9)]);
var inst_18902 = (state_18937[(10)]);
var inst_18894 = (state_18937[(7)]);
var inst_18908 = inst_18894.push(inst_18898);
var tmp18968 = inst_18894;
var inst_18894__$1 = tmp18968;
var inst_18895 = inst_18902;
var state_18937__$1 = (function (){var statearr_18973 = state_18937;
(statearr_18973[(7)] = inst_18894__$1);

(statearr_18973[(14)] = inst_18908);

(statearr_18973[(8)] = inst_18895);

return statearr_18973;
})();
var statearr_18974_19039 = state_18937__$1;
(statearr_18974_19039[(2)] = null);

(statearr_18974_19039[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__13855__auto___18986,out))
;
return ((function (switch__13839__auto__,c__13855__auto___18986,out){
return (function() {
var cljs$core$async$state_machine__13840__auto__ = null;
var cljs$core$async$state_machine__13840__auto____0 = (function (){
var statearr_18978 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_18978[(0)] = cljs$core$async$state_machine__13840__auto__);

(statearr_18978[(1)] = (1));

return statearr_18978;
});
var cljs$core$async$state_machine__13840__auto____1 = (function (state_18937){
while(true){
var ret_value__13841__auto__ = (function (){try{while(true){
var result__13842__auto__ = switch__13839__auto__.call(null,state_18937);
if(cljs.core.keyword_identical_QMARK_.call(null,result__13842__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__13842__auto__;
}
break;
}
}catch (e18979){if((e18979 instanceof Object)){
var ex__13843__auto__ = e18979;
var statearr_18980_19044 = state_18937;
(statearr_18980_19044[(5)] = ex__13843__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_18937);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e18979;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__13841__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19047 = state_18937;
state_18937 = G__19047;
continue;
} else {
return ret_value__13841__auto__;
}
break;
}
});
cljs$core$async$state_machine__13840__auto__ = function(state_18937){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__13840__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__13840__auto____1.call(this,state_18937);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__13840__auto____0;
cljs$core$async$state_machine__13840__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__13840__auto____1;
return cljs$core$async$state_machine__13840__auto__;
})()
;})(switch__13839__auto__,c__13855__auto___18986,out))
})();
var state__13857__auto__ = (function (){var statearr_18981 = f__13856__auto__.call(null);
(statearr_18981[cljs.core.async.impl.ioc_helpers.USER_START_IDX] = c__13855__auto___18986);

return statearr_18981;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__13857__auto__);
});})(c__13855__auto___18986,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

